<?php
	#
	# MySQL-Front Version 3.2.2.10
	# Copyright Copyright (C) 2000-2005
	# PHP tunneling engine
	# This script is used by the Windows GUI MySQL-Front only
	# http://www.mysqlfront.de/
	#

	$VersionStr = '1.1.7';
	
	error_reporting(E_ERROR | E_PARSE);
	
	$encodings = array(
		'ascii' => 'us-ascii',
		'big5' => 'big5',
		'cp367' => 'windows-1252',
		'cp437' => 'ibm437',
		'cp819' => 'iso-8859-1',
		'cp852' => 'ibm852',
		'cp1256' => 'windows-1256',
		'gb2312' => 'gb2312',
		'czech' => 'windows-1250',
		'euckr' => 'euc-kr',
		'eucjp' => 'euc-jp',
		'gbk' => 'gb2312',
		'greek' => 'iso-8859-7',
		'hebrew' => 'iso-8859-8',
		'koi8>' => 'koi8',
		'koi8u' => 'koi8-u',
		'koi8r' => 'koi8-r',
		'latin1' => 'iso-8859-1',
		'latin2' => 'iso-8859-2',
		'latin3' => 'iso-8859-3',
		'latin4' => 'iso-8859-4',
		'latin5' => 'iso-8859-5',
		'latin6' => 'iso-8859-6',
		'latin7' => 'iso-8859-7',
		'latin8' => 'iso-8859-8',
		'latin9' => 'iso-8859-9',
		'tis620' => 'windows-874',
		'ujis' => 'iso-2022-jp',
		'utf7' => 'utf-7',
		'utf8' => 'utf-8',
		'win1250' => 'windows-1250',
		'windows-1251' => 'iso-8859-1'
	);
	
	function xmlentities($String) {
		$Result = $String;
		
		$Result = ereg_replace('&', '&amp;', $Result);
		$Result = ereg_replace('<', '&lt;', $Result);
		$Result = ereg_replace('>', '&gt;', $Result);
		$Result = ereg_replace("\r", '\r', $Result);
		$Result = ereg_replace("\n", '\n', $Result);
		$Result = ereg_replace("\'", '&apos;', $Result);
		$Result = ereg_replace('"', '&quot;', $Result);
		for ($i = 1; $i < 32; $i++)
			$Result = ereg_replace(chr($i), '\x' . bin2hex(chr($i)), $Result);
		
		return $Result;
	}
	
	foreach(array_keys($_POST) as $Name)
		$$Name = stripslashes($_POST[$Name]);
	
	if (! isset($host)) $host = 'localhost';
	if (! isset($date_encoding)) $date_encoding = 'Y-m-d';
	if (! isset($time_encoding)) $time_encoding = 'H:i:s';
	if (! isset($datetime_encoding)) $datetime_encoding = $date_encoding . ' ' . $time_encoding;
	
	if (($function == 'mysql_connect') || ($function == 'mysql_real_connect')) {
		if (! isset($timeout)) $timeout = 30;
		set_time_limit($timeout);
	}
	else
		set_time_limit(0);
	
	if (version_compare(phpversion(), '4.3.0') >= 0)
		$mysql = mysql_connect($host . ':' . $port, $user, $password, true, (int) $clientflag);
	if (! isset($mysql) || mysql_errno($mysql) != 0)
		$mysql = mysql_connect($host . ':' . $port, $user, $password);
	if (($mysql) && (mysql_errno($mysql) == 0)) {
		if ($database)
			mysql_select_db($database, $mysql);
		if (version_compare(phpversion(), '4.0.5') >= 0)
			if (version_compare(mysql_get_server_info($mysql), '4.1.0') >= 0) {
				mysql_query('SET SESSION date_format=\'%Y-%m-%d\';', $mysql);
				mysql_query('SET SESSION datetime_format=\'%Y-%m-%d %H:%i:%s\';', $mysql);
				mysql_query('SET SESSION time_format=\'%H:%i:%s\';', $mysql);
			}
		if ($charset)
			mysql_query('SET CHARACTER SET \'' . $charset . '\';', $mysql);
		if (version_compare(mysql_get_server_info($mysql), '4.1.0') < 0)
			$result = mysql_query('SHOW VARIABLES LIKE \'character_set\';', $mysql);
		else
			$result = mysql_query('SHOW VARIABLES LIKE \'character_set_connection\';', $mysql);
		if (($Row = mysql_fetch_array($result, MYSQL_NUM)) && ($Row[1]))
		  $charset = $Row[1];
	}
	
	ob_start();
	
	echo '<?xml version="1.0" encoding="' . $encodings[$charset] . '"?>';
	echo '<mysql>';
	if (($function == 'mysql_connect') || ($function == 'mysql_real_connect')) {
		echo '<tunnel_info>' . $VersionStr . '</tunnel_info>';
		echo '<client_info>' . xmlentities(mysql_get_client_info($mysql)) . '</client_info>';
		echo '<host_info>' . xmlentities(mysql_get_host_info($mysql)) . '</host_info>';
		echo '<php_info>' . xmlentities(phpversion()) . '</php_info>';
		echo '<server_info>' . xmlentities(mysql_get_server_info($mysql)) . '</server_info>';
		if (mysql_errno()) {
			echo '<errno>' . (int) mysql_errno() . '</errno>';
			echo '<error>' . xmlentities(mysql_error()) . '</error>';
		}
		if (version_compare(mysql_get_server_info($mysql), '4.1.0') < 0) {
			$result = mysql_query('SHOW VARIABLES LIKE \'character_set\';', $mysql);
			if (($Row = mysql_fetch_array($result, MYSQL_NUM)) && ($Row[1]))
				echo '<character_set_name>' . xmlentities($Row[1]) . '</character_set_name>';
		}	else {
			$result = mysql_query('SHOW COLLATION WHERE `Charset` = @@character_set_connection AND `Default` = \'Yes\';', $mysql);
			if (($Row = mysql_fetch_array($result, MYSQL_NUM)) && ($Row[0]))
				echo '<character_set_name>' . xmlentities($Row[0]) . '</character_set_name>';
		}
	}
	for ($q = 0; $q < $query_count; $q++) if (mysql_errno() == 0) {
		$var_name = 'query_' . $q;
		$result = mysql_query($$var_name, $mysql);
		
		echo '<result>';
		if ($result) {
			echo '<affected_rows>' . mysql_affected_rows($mysql) . '</affected_rows>';
			if ((int) mysql_insert_id($mysql) > 0)
				echo '<insert_id>' . mysql_insert_id($mysql) . '</insert_id>';
			
			if (mysql_num_fields($result) > 0) {
				echo '<fields>';
					for ($i = 0; $i < mysql_num_fields($result); $i++) {
						$Fields[$i] = mysql_fetch_field($result, $i);
						echo '<field>';
						echo '<name>' . xmlentities($Fields[$i]->name) . '</name>';
						echo '<table>' . xmlentities($Fields[$i]->table) . '</table>';
						echo '<type>' . mysql_field_type($result, $i) . '</type>';
						echo '<length>' . (int) mysql_field_len($result, $i) . '</length>';
						if (mysql_field_type($result, $i) == 'real') {
							while (($Row = mysql_fetch_array($result, MYSQL_NUM)) && (! isset($Row[$i]))) ;
							if (isset($Row))
								echo '<decimals>' . (int) (StrLen($Row[$i]) - StrPos($Row[$i], '.') - 1) . '</decimals>';
							mysql_data_seek($result, 0);
						}
						echo '<max_length>' . (int) $Fields[$i]->max_length . '</max_length>';
						echo '<flags>';
						foreach (explode(' ', trim(mysql_field_flags($result, $i))) as $flag)
							if ($flag)
								echo '<flag>' . $flag . '</flag>';
						echo '</flags>';
						echo '</field>';
					}
				echo '</fields>';
			}
			
			if (mysql_num_rows($result) > 0) {
				echo '<rows>';
				while ($Row = mysql_fetch_array($result, MYSQL_NUM)) {
					echo '<row>';
					for ($i = 0; $i < mysql_num_fields($result); $i++)
						if (! isset($Row[$i]) && ! $Fields[$i]->not_null)
							echo '<data null="1"/>';
						else
							echo '<field>' . xmlentities($Row[$i]) . '</field>';
					echo '</row>';
				}
				echo '</rows>';
			}
		}
		if (version_compare(phpversion(), '4.3.0') >= 0)
			echo '<info>' . xmlentities(mysql_info()) . '</info>';
		if (mysql_errno()) {
			echo '<errno>' . (int) mysql_errno() . '</errno>';
			echo '<error>' . xmlentities(mysql_error()) . '</error>';
		}
		echo '</result>';
	}
	echo '</mysql>';
	
	mysql_close($mysql);
	
	$xml = ob_get_contents();
	ob_end_clean();
	
	if (! eregi('gzip', $HTTP_SERVER_VARS['HTTP_ACCEPT_ENCODING']) || ! extension_loaded('zlib'))
		echo $xml;
	else {
	 	header('Content-Encoding: gzip');
		
		$gz = gzcompress($xml, 9);
		$gz = substr($gz, 0, strlen($gz) - 4);
		
		echo "\x1f\x8b\x08\x00\x00\x00\x00\x00";
		echo $gz;
		echo pack('V', crc32($xml));
		echo pack('V', strlen($xml));
	}
?>

