-- phpMyAdmin SQL Dump
-- version 2.6.1-pl3
-- http://www.phpmyadmin.net
-- 
-- : localhost
--  :  12 2006 ., 21:24
--  : 4.0.24
--  PHP: 4.3.10-10
-- 
-- : `phpby06`
-- 
CREATE DATABASE `phpby06`;
USE phpby06;

-- --------------------------------------------------------

-- 
--   `dating_accounts`
-- 

CREATE TABLE `dating_accounts` (
  `id` int(6) unsigned NOT NULL auto_increment,
  `pseudo_id` int(6) unsigned default '0',
  `state` smallint(5) unsigned default NULL,
  `photo` varchar(255) default NULL,
  `creation_date` date default NULL,
  `activation_date` date default NULL,
  `thread_id` int(6) unsigned default NULL,
  `datingfolder_id` int(6) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `id` (`id`),
  KEY `id_2` (`id`)
) TYPE=MyISAM AUTO_INCREMENT=5 ;

-- 
--    `dating_accounts`
-- 

-- --------------------------------------------------------

-- 
--   `dating_advanced_badnesses`
-- 

CREATE TABLE `dating_advanced_badnesses` (
  `id` int(6) unsigned NOT NULL auto_increment,
  `dating_accounts_id` int(6) unsigned default '0',
  `dating_criteria_id` int(6) unsigned default '0',
  `lowvalue` int(3) unsigned default '0',
  `highvalue` int(3) unsigned default '0',
  `value` int(3) unsigned default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `id` (`id`),
  KEY `id_2` (`id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

-- 
--    `dating_advanced_badnesses`
-- 


-- --------------------------------------------------------

-- 
--   `dating_badnesses`
-- 

CREATE TABLE `dating_badnesses` (
  `id` int(6) unsigned NOT NULL auto_increment,
  `dating_accounts_id` int(6) unsigned default '0',
  `dating_criteria_id` int(6) unsigned default '0',
  `dating_cases_id` int(6) unsigned default '0',
  `value` int(1) unsigned default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `id` (`id`),
  KEY `id_2` (`id`)
) TYPE=MyISAM AUTO_INCREMENT=59 ;

-- 
--    `dating_badnesses`
-- 

-- --------------------------------------------------------

-- 
--   `dating_cases`
-- 

CREATE TABLE `dating_cases` (
  `id` int(6) unsigned NOT NULL default '0',
  `dating_criteria_id` int(6) unsigned default NULL,
  `name` varchar(255) default NULL,
  `parent_case_id` int(6) unsigned default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `id` (`id`),
  KEY `id_2` (`id`)
) TYPE=MyISAM;

-- 
--    `dating_cases`
-- 

INSERT INTO `dating_cases` VALUES (4, 3, 'No', 4);
INSERT INTO `dating_cases` VALUES (3, 1, 'Other', 3);
INSERT INTO `dating_cases` VALUES (2, 1, 'Male', 2);
INSERT INTO `dating_cases` VALUES (1, 1, 'Female', 1);
INSERT INTO `dating_cases` VALUES (5, 3, 'A little but I can stop', 5);
INSERT INTO `dating_cases` VALUES (6, 3, 'A little', 6);
INSERT INTO `dating_cases` VALUES (7, 3, 'Yes', 7);
INSERT INTO `dating_cases` VALUES (8, 5, 'Single', 8);
INSERT INTO `dating_cases` VALUES (9, 5, 'Married', 9);
INSERT INTO `dating_cases` VALUES (10, 5, 'Divorced', 10);
INSERT INTO `dating_cases` VALUES (11, 6, '0', 11);
INSERT INTO `dating_cases` VALUES (12, 6, '1', 12);
INSERT INTO `dating_cases` VALUES (13, 6, 'More', 13);
INSERT INTO `dating_cases` VALUES (14, 9, 'Green', 14);
INSERT INTO `dating_cases` VALUES (15, 9, 'Gray', 15);
INSERT INTO `dating_cases` VALUES (16, 9, 'Black', 16);
INSERT INTO `dating_cases` VALUES (17, 9, 'Blue', 17);
INSERT INTO `dating_cases` VALUES (18, 10, 'Blond/blonde', 18);
INSERT INTO `dating_cases` VALUES (19, 10, 'Brunet/brunette', 19);
INSERT INTO `dating_cases` VALUES (20, 10, 'etc', 20);
INSERT INTO `dating_cases` VALUES (21, 11, 'Short', 21);
INSERT INTO `dating_cases` VALUES (22, 11, 'Long', 22);
INSERT INTO `dating_cases` VALUES (23, 11, 'Middle', 23);
INSERT INTO `dating_cases` VALUES (24, 11, 'etc', 24);
INSERT INTO `dating_cases` VALUES (25, 13, 'ethnicity_1', 25);
INSERT INTO `dating_cases` VALUES (26, 13, 'ethnicity_2', 26);
INSERT INTO `dating_cases` VALUES (27, 13, 'ethnicity_3', 27);
INSERT INTO `dating_cases` VALUES (28, 14, 'Orthodoxy', 28);
INSERT INTO `dating_cases` VALUES (29, 14, 'Catholicism', 29);
INSERT INTO `dating_cases` VALUES (30, 14, 'Buddhism', 30);
INSERT INTO `dating_cases` VALUES (31, 14, 'Islam', 31);
INSERT INTO `dating_cases` VALUES (32, 14, 'etc', 32);
INSERT INTO `dating_cases` VALUES (33, 15, 'No education', 33);
INSERT INTO `dating_cases` VALUES (34, 15, 'Junior school', 34);
INSERT INTO `dating_cases` VALUES (35, 15, 'High school', 35);
INSERT INTO `dating_cases` VALUES (36, 15, 'College', 36);
INSERT INTO `dating_cases` VALUES (37, 15, 'high', 37);
INSERT INTO `dating_cases` VALUES (38, 15, 'incomplete high', 38);
INSERT INTO `dating_cases` VALUES (39, 17, 'No', 39);
INSERT INTO `dating_cases` VALUES (40, 17, 'A little', 40);
INSERT INTO `dating_cases` VALUES (41, 17, 'Yes', 41);
INSERT INTO `dating_cases` VALUES (44, 2, 'No', 44);
INSERT INTO `dating_cases` VALUES (43, 2, 'Sometimes', 43);
INSERT INTO `dating_cases` VALUES (42, 2, 'Yes', 42);
INSERT INTO `dating_cases` VALUES (45, 12, 'ROOT_1', 45);
INSERT INTO `dating_cases` VALUES (46, 12, 'ROOT_2', 46);
INSERT INTO `dating_cases` VALUES (47, 12, 'child_2_1', 46);
INSERT INTO `dating_cases` VALUES (48, 12, 'child_2_2', 46);
INSERT INTO `dating_cases` VALUES (49, 12, 'child_2_3', 46);
INSERT INTO `dating_cases` VALUES (50, 12, 'child_2_2_1', 48);
INSERT INTO `dating_cases` VALUES (51, 12, 'child_1_1', 45);
INSERT INTO `dating_cases` VALUES (52, 13, 'ETHNICITY!', 26);
INSERT INTO `dating_cases` VALUES (53, 13, 'ETH1', 52);
INSERT INTO `dating_cases` VALUES (54, 13, 'ETH2', 53);
INSERT INTO `dating_cases` VALUES (55, 13, 'Eth3', 54);
INSERT INTO `dating_cases` VALUES (56, 13, 'eth33', 55);
INSERT INTO `dating_cases` VALUES (57, 18, 'Holidays', 57);
INSERT INTO `dating_cases` VALUES (58, 18, 'Correspondence', 58);
INSERT INTO `dating_cases` VALUES (59, 18, 'Short relationship', 59);
INSERT INTO `dating_cases` VALUES (60, 18, 'Long relationship', 60);
INSERT INTO `dating_cases` VALUES (61, 18, 'Marriage', 61);
INSERT INTO `dating_cases` VALUES (62, 19, 'Yes', 62);
INSERT INTO `dating_cases` VALUES (63, 19, 'No', 63);

-- --------------------------------------------------------

-- 
--   `dating_conv_qual_badnesses`
-- 

CREATE TABLE `dating_conv_qual_badnesses` (
  `dating_accounts_id` int(6) unsigned default '0',
  `case1` tinyint(3) unsigned default '0',
  `case2` tinyint(3) unsigned default '0',
  `case3` tinyint(3) unsigned default '0',
  `case4` tinyint(3) unsigned default '0',
  `case5` tinyint(3) unsigned default '0',
  `case6` tinyint(3) unsigned default '0',
  `willingness` tinyint(3) unsigned default '0',
  UNIQUE KEY `dating_accounts_id` (`dating_accounts_id`)
) TYPE=MyISAM;

-- 
--    `dating_conv_qual_badnesses`
-- 

-- --------------------------------------------------------

-- 
--   `dating_criteria`
-- 

CREATE TABLE `dating_criteria` (
  `id` int(6) unsigned NOT NULL auto_increment,
  `name` varchar(255) default NULL,
  `cases_count` int(1) default '0',
  `nochoice` enum('Y','N') NOT NULL default 'N',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `id` (`id`),
  KEY `id_2` (`id`)
) TYPE=MyISAM AUTO_INCREMENT=20 ;

-- 
--    `dating_criteria`
-- 

INSERT INTO `dating_criteria` VALUES (1, 'Gender', 0, 'N');
INSERT INTO `dating_criteria` VALUES (3, 'Drinking habits', 0, 'N');
INSERT INTO `dating_criteria` VALUES (4, 'Birth year', -1, 'N');
INSERT INTO `dating_criteria` VALUES (6, 'Children already in charge', 0, 'N');
INSERT INTO `dating_criteria` VALUES (7, 'Height', -1, 'N');
INSERT INTO `dating_criteria` VALUES (9, 'Eyes color', 0, 'N');
INSERT INTO `dating_criteria` VALUES (10, 'Hair color', 0, 'N');
INSERT INTO `dating_criteria` VALUES (11, 'Hair style', 0, 'N');
INSERT INTO `dating_criteria` VALUES (14, 'Religion or creed', 0, 'N');
INSERT INTO `dating_criteria` VALUES (18, 'Type of relationship', 0, 'Y');
INSERT INTO `dating_criteria` VALUES (19, 'Want children', 0, 'Y');
INSERT INTO `dating_criteria` VALUES (8, 'Weight', -1, 'N');
INSERT INTO `dating_criteria` VALUES (12, 'Natinality', 0, 'N');
INSERT INTO `dating_criteria` VALUES (2, 'Smoking habits', 0, 'N');
INSERT INTO `dating_criteria` VALUES (16, 'Income', -1, 'N');
INSERT INTO `dating_criteria` VALUES (15, 'Education', 0, 'N');
INSERT INTO `dating_criteria` VALUES (13, 'Ethnicity', 0, 'N');
INSERT INTO `dating_criteria` VALUES (5, 'Marutal status', 0, 'N');
INSERT INTO `dating_criteria` VALUES (17, 'Handicap', 0, 'N');

-- --------------------------------------------------------

-- 
--   `dating_folderssettings`
-- 

CREATE TABLE `dating_folderssettings` (
  `account_id` int(6) NOT NULL auto_increment,
  `uh` smallint(3) unsigned default '2',
  `uw` smallint(3) unsigned default '5',
  `u_sp` enum('N','Y') NOT NULL default 'Y',
  `th` smallint(3) unsigned default '2',
  `tw` smallint(3) unsigned default '5',
  `t_sp` enum('N','Y') NOT NULL default 'Y',
  `dh` smallint(3) unsigned default '2',
  `dw` smallint(3) unsigned default '5',
  `d_sp` enum('N','Y') NOT NULL default 'Y',
  `sh` smallint(3) unsigned default '2',
  `sw` smallint(3) unsigned default '5',
  `s_sp` enum('N','Y') NOT NULL default 'Y',
  `sph` smallint(3) unsigned default '2',
  `spw` smallint(3) unsigned default '5',
  `sp_sp` enum('N','Y') NOT NULL default 'Y',
  `languages` enum('Y','N') NOT NULL default 'Y',
  `badness` enum('Y','N') NOT NULL default 'Y',
  `bin_parameters` int(10) unsigned NOT NULL default '0',
  `dfe` enum('Y','N') NOT NULL default 'Y',
  `dfs` enum('Y','N') NOT NULL default 'Y',
  PRIMARY KEY  (`account_id`)
) TYPE=MyISAM AUTO_INCREMENT=4 ;

-- 
--    `dating_folderssettings`
-- 

-- --------------------------------------------------------

-- 
--   `dating_income_level_badnesses`
-- 

CREATE TABLE `dating_income_level_badnesses` (
  `dating_accounts_id` int(6) unsigned NOT NULL auto_increment,
  `case1` tinyint(3) unsigned default NULL,
  `case2` tinyint(3) unsigned default NULL,
  `case3` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`dating_accounts_id`),
  UNIQUE KEY `dating_accounts_id` (`dating_accounts_id`),
  KEY `dating_accounts_id_2` (`dating_accounts_id`)
) TYPE=MyISAM AUTO_INCREMENT=3 ;

-- 
--    `dating_income_level_badnesses`
-- 

-- --------------------------------------------------------

-- 
--   `dating_infos`
-- 

CREATE TABLE `dating_infos` (
  `id` int(6) unsigned NOT NULL auto_increment,
  `dating_criteria_id` int(6) unsigned default '0',
  `dating_cases_id` int(6) unsigned default '0',
  `dating_accounts_id` int(6) unsigned default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `id` (`id`),
  KEY `id_2` (`id`)
) TYPE=MyISAM AUTO_INCREMENT=20 ;

-- 
--    `dating_infos`
-- 

-- --------------------------------------------------------

-- 
--   `dating_langinfos`
-- 

CREATE TABLE `dating_langinfos` (
  `dating_lang_id` int(6) unsigned default '0',
  `quality` smallint(1) unsigned default '0',
  `dating_accounts_id` int(6) unsigned default '0',
  KEY `dating_accounts_id` (`dating_accounts_id`),
  KEY `dating_lang_id` (`dating_lang_id`)
) TYPE=MyISAM;

-- 
--    `dating_langinfos`
-- 

-- --------------------------------------------------------

-- 
--   `dating_languages`
-- 

CREATE TABLE `dating_languages` (
  `id` int(6) unsigned NOT NULL auto_increment,
  `name` varchar(255) default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `id` (`id`),
  KEY `id_2` (`id`)
) TYPE=MyISAM AUTO_INCREMENT=5 ;

-- 
--    `dating_languages`
-- 

INSERT INTO `dating_languages` VALUES (1, 'Russian language');
INSERT INTO `dating_languages` VALUES (2, 'English language');
INSERT INTO `dating_languages` VALUES (3, 'French language');
INSERT INTO `dating_languages` VALUES (4, 'German language');

-- --------------------------------------------------------

-- 
--   `dating_languages_cases`
-- 

CREATE TABLE `dating_languages_cases` (
  `id` int(6) unsigned NOT NULL auto_increment,
  `name` varchar(255) default NULL,
  `lang_zone_id` int(6) unsigned default '0',
  `quality` int(1) unsigned default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `id` (`id`),
  KEY `id_2` (`id`)
) TYPE=MyISAM AUTO_INCREMENT=13 ;

-- 
--    `dating_languages_cases`
-- 

INSERT INTO `dating_languages_cases` VALUES (1, 'Not speaking', 1, 1);
INSERT INTO `dating_languages_cases` VALUES (2, 'Something', 1, 2);
INSERT INTO `dating_languages_cases` VALUES (3, 'A little', 1, 3);
INSERT INTO `dating_languages_cases` VALUES (4, 'Manage well', 1, 4);
INSERT INTO `dating_languages_cases` VALUES (5, 'Good', 1, 5);
INSERT INTO `dating_languages_cases` VALUES (6, 'Very good / native', 1, 6);
INSERT INTO `dating_languages_cases` VALUES (7, 'not speaking', 1, 1);
INSERT INTO `dating_languages_cases` VALUES (8, 'something', 2, 2);
INSERT INTO `dating_languages_cases` VALUES (9, 'a little', 2, 3);
INSERT INTO `dating_languages_cases` VALUES (10, 'manage well', 2, 4);
INSERT INTO `dating_languages_cases` VALUES (11, 'good', 2, 5);
INSERT INTO `dating_languages_cases` VALUES (12, 'very good', 2, 6);

-- --------------------------------------------------------

-- 
--   `dating_matches`
-- 

CREATE TABLE `dating_matches` (
  `id` int(6) unsigned NOT NULL auto_increment,
  `date` date NOT NULL default '0000-00-00',
  `account_id1` int(6) unsigned default '0',
  `account_id2` int(6) unsigned default '0',
  `status1` enum('B','N','U','T','D','S','SP') default NULL,
  `status2` enum('B','N','U','T','D','S','SP') default NULL,
  `badness_value` smallint(1) unsigned default NULL,
  `language_id` int(6) unsigned NOT NULL default '0',
  `forum_id` int(6) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `id` (`id`),
  KEY `id_2` (`id`)
) TYPE=MyISAM AUTO_INCREMENT=3 ;

-- 
--    `dating_matches`
-- 

-- --------------------------------------------------------

-- 
--   `dating_mplaces`
-- 

CREATE TABLE `dating_mplaces` (
  `id` int(6) unsigned NOT NULL auto_increment,
  `name` varchar(255) default NULL,
  `parent_id` int(6) unsigned default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `id` (`id`),
  KEY `id_2` (`id`)
) TYPE=MyISAM AUTO_INCREMENT=24 ;

-- 
--    `dating_mplaces`
-- 

INSERT INTO `dating_mplaces` VALUES (1, 'europe', 1);
INSERT INTO `dating_mplaces` VALUES (2, 'africa', 2);
INSERT INTO `dating_mplaces` VALUES (3, 'asia', 3);
INSERT INTO `dating_mplaces` VALUES (4, 'south america', 4);
INSERT INTO `dating_mplaces` VALUES (5, 'north america', 5);
INSERT INTO `dating_mplaces` VALUES (6, 'usa', 5);
INSERT INTO `dating_mplaces` VALUES (7, 'canada', 5);
INSERT INTO `dating_mplaces` VALUES (8, 'argentine', 4);
INSERT INTO `dating_mplaces` VALUES (9, 'russia', 1);
INSERT INTO `dating_mplaces` VALUES (10, 'india', 3);
INSERT INTO `dating_mplaces` VALUES (11, 'northern', 2);
INSERT INTO `dating_mplaces` VALUES (12, 'southern', 2);
INSERT INTO `dating_mplaces` VALUES (13, 'china', 3);
INSERT INTO `dating_mplaces` VALUES (14, 'south_pole', 14);
INSERT INTO `dating_mplaces` VALUES (15, 'east russia', 9);
INSERT INTO `dating_mplaces` VALUES (16, 'west russia', 9);
INSERT INTO `dating_mplaces` VALUES (17, 'south-east russia', 15);
INSERT INTO `dating_mplaces` VALUES (18, 'north-east russia', 15);
INSERT INTO `dating_mplaces` VALUES (19, 'middle-east russia', 15);
INSERT INTO `dating_mplaces` VALUES (20, 'southern africa - I', 12);
INSERT INTO `dating_mplaces` VALUES (21, 'southern africa - II', 12);
INSERT INTO `dating_mplaces` VALUES (22, 'southpole1', 14);
INSERT INTO `dating_mplaces` VALUES (23, 'southpole11', 22);

-- --------------------------------------------------------

-- 
--   `dating_mplacesinfos`
-- 

CREATE TABLE `dating_mplacesinfos` (
  `dating_accounts_id` int(6) default NULL,
  `dating_mplace_id` int(6) unsigned default NULL,
  `income` tinyint(3) unsigned default NULL,
  `badness` tinyint(3) unsigned default NULL
) TYPE=MyISAM;

-- 
--    `dating_mplacesinfos`
-- 

-- --------------------------------------------------------

-- 
--   `dating_multilang_infos`
-- 

CREATE TABLE `dating_multilang_infos` (
  `id` int(6) unsigned NOT NULL auto_increment,
  `lang_zone_id` int(6) unsigned default '0',
  `key_id` int(6) unsigned default '0',
  `fromwhich` enum('Cr','Ca') NOT NULL default 'Cr',
  `name` text,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `id` (`id`),
  KEY `id_2` (`id`)
) TYPE=MyISAM AUTO_INCREMENT=6 ;

-- 
--    `dating_multilang_infos`
-- 

-- --------------------------------------------------------

-- 
--   `dating_multilang_languages`
-- 

CREATE TABLE `dating_multilang_languages` (
  `id` int(6) unsigned NOT NULL auto_increment,
  `language_id` int(6) unsigned default '0',
  `lang_zone_id` int(6) unsigned default '0',
  `name` text,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `id` (`id`),
  KEY `id_2` (`id`)
) TYPE=MyISAM AUTO_INCREMENT=4 ;

-- 
--    `dating_multilang_languages`
-- 

INSERT INTO `dating_multilang_languages` VALUES (1, 1, 2, 'russian');
INSERT INTO `dating_multilang_languages` VALUES (2, 3, 2, 'french');
INSERT INTO `dating_multilang_languages` VALUES (3, 2, 2, 'german');

-- --------------------------------------------------------

-- 
--   `dating_multilang_mplaces`
-- 

CREATE TABLE `dating_multilang_mplaces` (
  `id` int(6) unsigned NOT NULL auto_increment,
  `mplace_id` int(6) unsigned default NULL,
  `lang_zone_id` int(6) unsigned default NULL,
  `name` varchar(255) default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `id` (`id`),
  KEY `id_2` (`id`)
) TYPE=MyISAM AUTO_INCREMENT=3 ;

-- 
--    `dating_multilang_mplaces`
-- 

INSERT INTO `dating_multilang_mplaces` VALUES (1, 2, 2, 'africa');
INSERT INTO `dating_multilang_mplaces` VALUES (2, 8, 2, 'argentina');

-- --------------------------------------------------------

-- 
--   `dating_statusespriorities`
-- 

CREATE TABLE `dating_statusespriorities` (
  `status` enum('N','U','T','D','S','SP') NOT NULL default 'N',
  `priority` int(3) unsigned default '0',
  UNIQUE KEY `status` (`status`)
) TYPE=MyISAM;

-- 
--    `dating_statusespriorities`
-- 

INSERT INTO `dating_statusespriorities` VALUES ('N', 6);
INSERT INTO `dating_statusespriorities` VALUES ('U', 3);
INSERT INTO `dating_statusespriorities` VALUES ('T', 5);
INSERT INTO `dating_statusespriorities` VALUES ('D', 4);
INSERT INTO `dating_statusespriorities` VALUES ('S', 2);
INSERT INTO `dating_statusespriorities` VALUES ('SP', 1);

-- --------------------------------------------------------

-- 
--   `forums_accesses`
-- 

CREATE TABLE `forums_accesses` (
  `pseudo_id` int(6) default NULL,
  `pseudo_who_invited` int(6) default NULL,
  `forum_id` int(6) default NULL,
  `rights` enum('r','w','a') default NULL,
  `create_date` date default NULL,
  `view_inv` enum('Y','N') default NULL
) TYPE=MyISAM;

-- 
--    `forums_accesses`
-- 

-- --------------------------------------------------------

-- 
--   `forums_blacklist`
-- 

CREATE TABLE `forums_blacklist` (
  `forum_id` int(6) default NULL,
  `pseudo_id` int(6) default NULL,
  `denyto` enum('r','w') default NULL,
  `create_date` date default NULL
) TYPE=MyISAM;

-- 
--    `forums_blacklist`
-- 

-- --------------------------------------------------------

-- 
--   `forums_charset_table`
-- 

CREATE TABLE `forums_charset_table` (
  `id` int(6) NOT NULL auto_increment,
  `charset` varchar(255) default NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=1 ;

-- 
--    `forums_charset_table`
-- 


-- --------------------------------------------------------

-- 
--   `forums_contacts`
-- 

CREATE TABLE `forums_contacts` (
  `user_id` int(6) default NULL,
  `pseudo_id` int(6) default NULL
) TYPE=MyISAM;

-- 
--    `forums_contacts`
-- 

-- --------------------------------------------------------

-- 
--   `forums_customnames`
-- 

CREATE TABLE `forums_customnames` (
  `forum_id` int(6) default '0',
  `user_id` int(6) default '0',
  `customname` varchar(255) default '0'
) TYPE=MyISAM;

-- 
--    `forums_customnames`
-- 

-- --------------------------------------------------------

-- 
--   `forums_folders`
-- 

CREATE TABLE `forums_folders` (
  `id` int(6) NOT NULL auto_increment,
  `user_id` int(6) default NULL,
  `parent_id` int(6) default NULL,
  `name` varchar(255) default NULL,
  `boxtype` enum('MB','PF','child') default NULL,
  `deletable` enum('Y','N') NOT NULL default 'Y',
  `visible` enum('Y','N') NOT NULL default 'Y',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=339 ;

-- 
--    `forums_folders`
-- 

INSERT INTO `forums_folders` VALUES (211, 49, 0, 'Public forums', 'PF', 'Y', 'Y');
INSERT INTO `forums_folders` VALUES (210, 49, 0, 'MainBox', 'MB', 'Y', 'Y');

-- --------------------------------------------------------

-- 
--   `forums_forums`
-- 

CREATE TABLE `forums_forums` (
  `id` int(6) NOT NULL auto_increment,
  `pseudo_id` int(6) default NULL,
  `name` varchar(255) default NULL,
  `pub` enum('Y','N') default NULL,
  `comment` varchar(50) default NULL,
  `comment2` mediumtext,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=28 ;

-- 
--    `forums_forums`
-- 

-- --------------------------------------------------------

-- 
--   `forums_forums2folders`
-- 

CREATE TABLE `forums_forums2folders` (
  `forum_id` int(6) default NULL,
  `folder_id` int(6) default NULL
) TYPE=MyISAM;

-- 
--    `forums_forums2folders`
-- 

-- --------------------------------------------------------

-- 
--   `forums_lang_keys`
-- 

CREATE TABLE `forums_lang_keys` (
  `trans_id` int(6) NOT NULL default '0',
  `key_key` int(6) NOT NULL default '0',
  `value` varchar(255) default NULL,
  PRIMARY KEY  (`trans_id`,`key_key`)
) TYPE=MyISAM;

-- 
--    `forums_lang_keys`
-- 

INSERT INTO `forums_lang_keys` VALUES (1, 143, 'Do you want the user you''re inviting to be able to view the invitations table of this forum?');
INSERT INTO `forums_lang_keys` VALUES (1, 142, 'View forum rights');
INSERT INTO `forums_lang_keys` VALUES (1, 141, 'deny');
INSERT INTO `forums_lang_keys` VALUES (1, 140, 'allow');
INSERT INTO `forums_lang_keys` VALUES (1, 139, 'Invitations viewing access');
INSERT INTO `forums_lang_keys` VALUES (1, 138, 'default folder');
INSERT INTO `forums_lang_keys` VALUES (1, 137, 'bytes');
INSERT INTO `forums_lang_keys` VALUES (1, 135, 'Total number of users');
INSERT INTO `forums_lang_keys` VALUES (1, 136, 'Total disk space used');
INSERT INTO `forums_lang_keys` VALUES (1, 134, 'Total number of pseudos');
INSERT INTO `forums_lang_keys` VALUES (1, 133, 'Statistics');
INSERT INTO `forums_lang_keys` VALUES (1, 144, 'The user took part in the following private forums');
INSERT INTO `forums_lang_keys` VALUES (1, 132, 'Configuration');
INSERT INTO `forums_lang_keys` VALUES (1, 131, 'or you cannot add yourself or already existing in your contact list pseudo');
INSERT INTO `forums_lang_keys` VALUES (1, 130, 'Invitations you take part in:');
INSERT INTO `forums_lang_keys` VALUES (1, 129, 'Public forums');
INSERT INTO `forums_lang_keys` VALUES (1, 128, 'Pseudos who have posted messages (admins in bold):');
INSERT INTO `forums_lang_keys` VALUES (1, 127, 'Info');
INSERT INTO `forums_lang_keys` VALUES (1, 126, 'Help');
INSERT INTO `forums_lang_keys` VALUES (1, 125, 'Sorry, your session has expired. The message was posted but marked invalid. You can login again and validate it.');
INSERT INTO `forums_lang_keys` VALUES (1, 118, 'Folder already exists');
INSERT INTO `forums_lang_keys` VALUES (1, 98, 'Edit selected (left) translation');
INSERT INTO `forums_lang_keys` VALUES (1, 100, 'From contact list:');
INSERT INTO `forums_lang_keys` VALUES (1, 99, '---input myself!');
INSERT INTO `forums_lang_keys` VALUES (1, 101, 'Or input yourself:');
INSERT INTO `forums_lang_keys` VALUES (1, 102, 'to this forum with rights:');
INSERT INTO `forums_lang_keys` VALUES (1, 145, 'Ask admin to add a new language zone');
INSERT INTO `forums_lang_keys` VALUES (1, 146, 'MainBox');
INSERT INTO `forums_lang_keys` VALUES (1, 147, 'Custom name');
INSERT INTO `forums_lang_keys` VALUES (1, 148, 'Go to forum');
INSERT INTO `forums_lang_keys` VALUES (1, 103, 'Error: guests are never denied to read public forums!');
INSERT INTO `forums_lang_keys` VALUES (1, 149, 'Creator name');
INSERT INTO `forums_lang_keys` VALUES (1, 104, 'Secret question:');
INSERT INTO `forums_lang_keys` VALUES (1, 150, 'members');
INSERT INTO `forums_lang_keys` VALUES (1, 151, 'only you');
INSERT INTO `forums_lang_keys` VALUES (1, 105, 'Secret answer:');
INSERT INTO `forums_lang_keys` VALUES (1, 106, 'Forgot password?');
INSERT INTO `forums_lang_keys` VALUES (1, 152, 'Dating account');
INSERT INTO `forums_lang_keys` VALUES (1, 107, 'error: wrong answer!');
INSERT INTO `forums_lang_keys` VALUES (1, 153, 'Dating menu');
INSERT INTO `forums_lang_keys` VALUES (1, 154, 'Create your dating account');
INSERT INTO `forums_lang_keys` VALUES (1, 155, 'Your account already exists!');
INSERT INTO `forums_lang_keys` VALUES (1, 156, 'Your current account state is:');
INSERT INTO `forums_lang_keys` VALUES (1, 157, 'Your info isn''t filled in');
INSERT INTO `forums_lang_keys` VALUES (1, 158, 'Would you like to receive users'' advices about your photo?');
INSERT INTO `forums_lang_keys` VALUES (1, 108, 'Error: such pseudo already exists!');
INSERT INTO `forums_lang_keys` VALUES (1, 159, 'Your account doesn''t exist');
INSERT INTO `forums_lang_keys` VALUES (1, 160, 'Edit personal info');
INSERT INTO `forums_lang_keys` VALUES (1, 109, 'Error: you cannot cannot change permissions for yourself or the creator of the forum!');
INSERT INTO `forums_lang_keys` VALUES (1, 161, 'Choice');
INSERT INTO `forums_lang_keys` VALUES (1, 162, 'Cases');
INSERT INTO `forums_lang_keys` VALUES (1, 110, 'Resign my invitation');
INSERT INTO `forums_lang_keys` VALUES (1, 164, 'Empty badness field means');
INSERT INTO `forums_lang_keys` VALUES (1, 111, 'rename this folder');
INSERT INTO `forums_lang_keys` VALUES (1, 112, 'Enter new name:');
INSERT INTO `forums_lang_keys` VALUES (1, 165, 'Enter integer value');
INSERT INTO `forums_lang_keys` VALUES (1, 113, 'Where (choose a folder)?');
INSERT INTO `forums_lang_keys` VALUES (1, 115, 'by pseudo');
INSERT INTO `forums_lang_keys` VALUES (1, 166, 'from');
INSERT INTO `forums_lang_keys` VALUES (1, 48, 'Back');
INSERT INTO `forums_lang_keys` VALUES (1, 167, 'to');
INSERT INTO `forums_lang_keys` VALUES (1, 168, 'Other cases');
INSERT INTO `forums_lang_keys` VALUES (1, 114, 'new');
INSERT INTO `forums_lang_keys` VALUES (1, 169, 'Warning! Not all the fields are filled right correctly.');
INSERT INTO `forums_lang_keys` VALUES (1, 170, 'Photo not uploaded');
INSERT INTO `forums_lang_keys` VALUES (1, 116, 'Error: selected pseudo doesn');
INSERT INTO `forums_lang_keys` VALUES (1, 171, 'Personal info');
INSERT INTO `forums_lang_keys` VALUES (1, 117, 'My pseudos');
INSERT INTO `forums_lang_keys` VALUES (1, 172, 'Upload a photo');
INSERT INTO `forums_lang_keys` VALUES (1, 173, 'Photo uploaded.');
INSERT INTO `forums_lang_keys` VALUES (1, 119, 'My pseudos');
INSERT INTO `forums_lang_keys` VALUES (1, 120, 'Adding translation');
INSERT INTO `forums_lang_keys` VALUES (1, 121, 'Editing translation');
INSERT INTO `forums_lang_keys` VALUES (1, 122, 'subscribed');
INSERT INTO `forums_lang_keys` VALUES (1, 123, 'subscribe');
INSERT INTO `forums_lang_keys` VALUES (1, 124, 'unsubscribe');
INSERT INTO `forums_lang_keys` VALUES (1, 63, 'such forum already exists!');
INSERT INTO `forums_lang_keys` VALUES (1, 52, 'MaxAccess');
INSERT INTO `forums_lang_keys` VALUES (1, 3, '&lt;Title&gt;');
INSERT INTO `forums_lang_keys` VALUES (1, 2, 'Are you sure you want to delete thread');
INSERT INTO `forums_lang_keys` VALUES (1, 97, 'Compare (view) selected translations (left &amp; right)');
INSERT INTO `forums_lang_keys` VALUES (1, 96, 'Add new translation, based on selected one (left)');
INSERT INTO `forums_lang_keys` VALUES (1, 95, 'selections');
INSERT INTO `forums_lang_keys` VALUES (1, 94, 'Translation list');
INSERT INTO `forums_lang_keys` VALUES (1, 89, 'Use selected (left) translation');
INSERT INTO `forums_lang_keys` VALUES (1, 90, 'id');
INSERT INTO `forums_lang_keys` VALUES (1, 91, 'language');
INSERT INTO `forums_lang_keys` VALUES (1, 92, 'version');
INSERT INTO `forums_lang_keys` VALUES (1, 93, 'description');
INSERT INTO `forums_lang_keys` VALUES (1, 88, 'Sorry, you are not allowed to access this area!');
INSERT INTO `forums_lang_keys` VALUES (1, 87, 'not found.');
INSERT INTO `forums_lang_keys` VALUES (1, 86, 'is succesfully allowed to access current forum with selected rights!');
INSERT INTO `forums_lang_keys` VALUES (1, 85, 'user already exists!');
INSERT INTO `forums_lang_keys` VALUES (1, 84, 'Create forum');
INSERT INTO `forums_lang_keys` VALUES (1, 83, 'Add new permission');
INSERT INTO `forums_lang_keys` VALUES (1, 82, 'deny (delete)');
INSERT INTO `forums_lang_keys` VALUES (1, 81, 'invited by');
INSERT INTO `forums_lang_keys` VALUES (1, 80, 'permission');
INSERT INTO `forums_lang_keys` VALUES (1, 79, 'is already set!');
INSERT INTO `forums_lang_keys` VALUES (1, 78, 'Error: the permission for pseudo');
INSERT INTO `forums_lang_keys` VALUES (1, 77, 'in the database!');
INSERT INTO `forums_lang_keys` VALUES (1, 76, 'Error: there is no pseudo');
INSERT INTO `forums_lang_keys` VALUES (1, 74, 'allow! (delete from blacklist)');
INSERT INTO `forums_lang_keys` VALUES (1, 75, 'Add new denyence');
INSERT INTO `forums_lang_keys` VALUES (1, 73, 'admin');
INSERT INTO `forums_lang_keys` VALUES (1, 72, 'read');
INSERT INTO `forums_lang_keys` VALUES (1, 71, 'write');
INSERT INTO `forums_lang_keys` VALUES (1, 70, 'Change permission');
INSERT INTO `forums_lang_keys` VALUES (1, 69, 'Date');
INSERT INTO `forums_lang_keys` VALUES (1, 67, 'Rights editor');
INSERT INTO `forums_lang_keys` VALUES (1, 68, 'Deny to');
INSERT INTO `forums_lang_keys` VALUES (1, 66, 'Create!');
INSERT INTO `forums_lang_keys` VALUES (1, 65, 'Enter new');
INSERT INTO `forums_lang_keys` VALUES (1, 64, 'By pseudo');
INSERT INTO `forums_lang_keys` VALUES (1, 62, 'Creating new forum.');
INSERT INTO `forums_lang_keys` VALUES (1, 61, 'Threads');
INSERT INTO `forums_lang_keys` VALUES (1, 60, 'Thread');
INSERT INTO `forums_lang_keys` VALUES (1, 59, 'Forum');
INSERT INTO `forums_lang_keys` VALUES (1, 58, 'Folder');
INSERT INTO `forums_lang_keys` VALUES (1, 57, 'Add pseudo to contact list');
INSERT INTO `forums_lang_keys` VALUES (1, 55, 'Enter pseudo:');
INSERT INTO `forums_lang_keys` VALUES (1, 56, 'Contact list');
INSERT INTO `forums_lang_keys` VALUES (1, 54, 'Invite');
INSERT INTO `forums_lang_keys` VALUES (1, 53, 'Sorry, you are not allowed to access this area');
INSERT INTO `forums_lang_keys` VALUES (1, 51, 'Edit forum rights');
INSERT INTO `forums_lang_keys` VALUES (1, 50, 'Viewing pseudo information');
INSERT INTO `forums_lang_keys` VALUES (1, 49, 'Enter new comment2 for pseudo');
INSERT INTO `forums_lang_keys` VALUES (1, 47, 'comment2');
INSERT INTO `forums_lang_keys` VALUES (1, 46, 'You were succesfully registered in the system. Don''t forget your login and password!');
INSERT INTO `forums_lang_keys` VALUES (1, 44, 'E-mail:');
INSERT INTO `forums_lang_keys` VALUES (1, 45, 'Register!');
INSERT INTO `forums_lang_keys` VALUES (1, 43, 'Password:');
INSERT INTO `forums_lang_keys` VALUES (1, 42, 'Username:');
INSERT INTO `forums_lang_keys` VALUES (1, 41, 'Register new user');
INSERT INTO `forums_lang_keys` VALUES (1, 36, 'Move...');
INSERT INTO `forums_lang_keys` VALUES (1, 40, 'Translations');
INSERT INTO `forums_lang_keys` VALUES (1, 39, 'Enter new name for the thread:');
INSERT INTO `forums_lang_keys` VALUES (1, 38, 'Move to folder...');
INSERT INTO `forums_lang_keys` VALUES (1, 37, 'Change');
INSERT INTO `forums_lang_keys` VALUES (1, 35, 'Wrong password');
INSERT INTO `forums_lang_keys` VALUES (1, 34, 'Would you like all forums in this and sub- folders to be moved to the root? If you answer ''N'', you''ll lose your invitations!');
INSERT INTO `forums_lang_keys` VALUES (1, 33, 'Validate');
INSERT INTO `forums_lang_keys` VALUES (1, 32, 'Username not found');
INSERT INTO `forums_lang_keys` VALUES (1, 31, 'U S E R  M E N U');
INSERT INTO `forums_lang_keys` VALUES (1, 30, 'to:');
INSERT INTO `forums_lang_keys` VALUES (1, 29, '---rename---');
INSERT INTO `forums_lang_keys` VALUES (1, 28, '---remove pseudo---');
INSERT INTO `forums_lang_keys` VALUES (1, 27, 'Registration');
INSERT INTO `forums_lang_keys` VALUES (1, 26, '---register new pseudo---');
INSERT INTO `forums_lang_keys` VALUES (1, 25, 'Pseudos settings');
INSERT INTO `forums_lang_keys` VALUES (1, 24, 'pseudo');
INSERT INTO `forums_lang_keys` VALUES (1, 23, 'Title:');
INSERT INTO `forums_lang_keys` VALUES (1, 22, '---New thread---');
INSERT INTO `forums_lang_keys` VALUES (1, 21, '---New reply');
INSERT INTO `forums_lang_keys` VALUES (1, 20, 'name');
INSERT INTO `forums_lang_keys` VALUES (1, 19, '---mark valid!---');
INSERT INTO `forums_lang_keys` VALUES (1, 18, '---mark invalid!---');
INSERT INTO `forums_lang_keys` VALUES (1, 17, 'Exit');
INSERT INTO `forums_lang_keys` VALUES (1, 16, '---erase---');
INSERT INTO `forums_lang_keys` VALUES (1, 15, 'Enter new pseudo name:');
INSERT INTO `forums_lang_keys` VALUES (1, 14, 'Enter new comment for pseudo');
INSERT INTO `forums_lang_keys` VALUES (1, 13, 'Enter name for the new thread:');
INSERT INTO `forums_lang_keys` VALUES (1, 12, 'Enter name for the new folder:');
INSERT INTO `forums_lang_keys` VALUES (1, 11, '---edit---');
INSERT INTO `forums_lang_keys` VALUES (1, 10, 'Do you really want to remove pseudo');
INSERT INTO `forums_lang_keys` VALUES (1, 9, 'delete this folder');
INSERT INTO `forums_lang_keys` VALUES (1, 8, '---delete---');
INSERT INTO `forums_lang_keys` VALUES (1, 7, 'creation date');
INSERT INTO `forums_lang_keys` VALUES (1, 6, 'create subfolder');
INSERT INTO `forums_lang_keys` VALUES (1, 5, 'comment');
INSERT INTO `forums_lang_keys` VALUES (1, 4, 'Choose a folder to move selected forums to:');
INSERT INTO `forums_lang_keys` VALUES (1, 1, 'actions');
INSERT INTO `forums_lang_keys` VALUES (1, 174, 'Upload another');
INSERT INTO `forums_lang_keys` VALUES (1, 175, 'Photo');
INSERT INTO `forums_lang_keys` VALUES (1, 176, 'Not activated');
INSERT INTO `forums_lang_keys` VALUES (1, 177, 'Activate account');
INSERT INTO `forums_lang_keys` VALUES (1, 178, 'Yes, ask for advices about my photo');
INSERT INTO `forums_lang_keys` VALUES (1, 179, 'No, don''t ask for advices nut let the users send me messages if they wish');
INSERT INTO `forums_lang_keys` VALUES (1, 180, 'Main page');
INSERT INTO `forums_lang_keys` VALUES (1, 181, 'Languages');
INSERT INTO `forums_lang_keys` VALUES (1, 182, 'Your quality');
INSERT INTO `forums_lang_keys` VALUES (1, 183, 'Are you ready to learn the other''s language?');
INSERT INTO `forums_lang_keys` VALUES (1, 184, 'Select badnesses for each possible quality of conversation');
INSERT INTO `forums_lang_keys` VALUES (1, 185, 'Between');
INSERT INTO `forums_lang_keys` VALUES (1, 186, 'Advices forum (F)');
INSERT INTO `forums_lang_keys` VALUES (1, 187, 'Advices forum (M)');
INSERT INTO `forums_lang_keys` VALUES (1, 188, 'Unreviewed');
INSERT INTO `forums_lang_keys` VALUES (1, 189, 'Trash');
INSERT INTO `forums_lang_keys` VALUES (1, 190, 'Delayed');
INSERT INTO `forums_lang_keys` VALUES (1, 191, 'Selected');
INSERT INTO `forums_lang_keys` VALUES (1, 192, 'Selected+');
INSERT INTO `forums_lang_keys` VALUES (1, 193, 'Common settings');
INSERT INTO `forums_lang_keys` VALUES (1, 194, 'Dating link visible on top');
INSERT INTO `forums_lang_keys` VALUES (1, 195, 'Send account');
INSERT INTO `forums_lang_keys` VALUES (1, 196, 'Are you sure you want to activate your account?');
INSERT INTO `forums_lang_keys` VALUES (1, 197, 'Yes');
INSERT INTO `forums_lang_keys` VALUES (1, 198, 'No');
INSERT INTO `forums_lang_keys` VALUES (1, 199, 'Folders settings');
INSERT INTO `forums_lang_keys` VALUES (1, 200, 'Width');
INSERT INTO `forums_lang_keys` VALUES (1, 201, 'Height');
INSERT INTO `forums_lang_keys` VALUES (1, 202, 'Store');
INSERT INTO `forums_lang_keys` VALUES (1, 203, 'Show');
INSERT INTO `forums_lang_keys` VALUES (1, 204, 'Forum link');
INSERT INTO `forums_lang_keys` VALUES (1, 205, 'Parameter');
INSERT INTO `forums_lang_keys` VALUES (1, 206, 'Move to');
INSERT INTO `forums_lang_keys` VALUES (1, 207, 'Your status');
INSERT INTO `forums_lang_keys` VALUES (1, 208, 'Unlisted');
INSERT INTO `forums_lang_keys` VALUES (1, 209, 'The folder is empty');
INSERT INTO `forums_lang_keys` VALUES (1, 210, 'Next');
INSERT INTO `forums_lang_keys` VALUES (1, 211, 'Previous');
INSERT INTO `forums_lang_keys` VALUES (1, 212, 'Page');
INSERT INTO `forums_lang_keys` VALUES (1, 213, 'Webmail');
INSERT INTO `forums_lang_keys` VALUES (1, 214, 'Place of a meeting');
INSERT INTO `forums_lang_keys` VALUES (1, 215, 'Region');
INSERT INTO `forums_lang_keys` VALUES (1, 216, 'Would have income there');
INSERT INTO `forums_lang_keys` VALUES (1, 217, 'A little or perhaps');
INSERT INTO `forums_lang_keys` VALUES (1, 218, 'if');
INSERT INTO `forums_lang_keys` VALUES (1, 219, 'Forums');
INSERT INTO `forums_lang_keys` VALUES (1, 220, 'Account management');
INSERT INTO `forums_lang_keys` VALUES (1, 221, 'Deactivate account');
INSERT INTO `forums_lang_keys` VALUES (1, 222, 'Start asking for advices');
INSERT INTO `forums_lang_keys` VALUES (1, 223, 'Stop asking for advices');
INSERT INTO `forums_lang_keys` VALUES (1, 224, 'Dating forums');
INSERT INTO `forums_lang_keys` VALUES (1, 225, 'View parameters');
INSERT INTO `forums_lang_keys` VALUES (1, 226, '&quot;Dating forums&quot; folder visible');
INSERT INTO `forums_lang_keys` VALUES (1, 227, 'Subscribe by default');
INSERT INTO `forums_lang_keys` VALUES (1, 234, 'rename forum');
INSERT INTO `forums_lang_keys` VALUES (1, 233, 'Sure?');
INSERT INTO `forums_lang_keys` VALUES (1, 232, 'change link');
INSERT INTO `forums_lang_keys` VALUES (1, 231, 'Thread attached link');
INSERT INTO `forums_lang_keys` VALUES (1, 230, 'specify a valid name, please');
INSERT INTO `forums_lang_keys` VALUES (1, 229, 'Choose');
INSERT INTO `forums_lang_keys` VALUES (1, 228, 'Invitations');
INSERT INTO `forums_lang_keys` VALUES (1, 235, 'Save');
INSERT INTO `forums_lang_keys` VALUES (1, 236, 'Preview');
INSERT INTO `forums_lang_keys` VALUES (1, 237, 'Post');
INSERT INTO `forums_lang_keys` VALUES (1, 238, 'You can edit message here:');
INSERT INTO `forums_lang_keys` VALUES (1, 239, 'Message preview:');
INSERT INTO `forums_lang_keys` VALUES (1, 240, 'Warning! Someone has posted a new message.');
INSERT INTO `forums_lang_keys` VALUES (1, 241, 'Resign from admin rights');
INSERT INTO `forums_lang_keys` VALUES (1, 242, 'Sorry, you can not resign');
INSERT INTO `forums_lang_keys` VALUES (9, 1, '');
INSERT INTO `forums_lang_keys` VALUES (9, 2, '    ?');
INSERT INTO `forums_lang_keys` VALUES (9, 3, '');
INSERT INTO `forums_lang_keys` VALUES (9, 4, '   ');
INSERT INTO `forums_lang_keys` VALUES (9, 5, '');
INSERT INTO `forums_lang_keys` VALUES (9, 6, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 7, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 8, '');
INSERT INTO `forums_lang_keys` VALUES (9, 9, '  ');
INSERT INTO `forums_lang_keys` VALUES (9, 10, '    ');
INSERT INTO `forums_lang_keys` VALUES (9, 11, '');
INSERT INTO `forums_lang_keys` VALUES (9, 12, '    :');
INSERT INTO `forums_lang_keys` VALUES (9, 13, '    :');
INSERT INTO `forums_lang_keys` VALUES (9, 14, '    ');
INSERT INTO `forums_lang_keys` VALUES (9, 15, '   ');
INSERT INTO `forums_lang_keys` VALUES (9, 16, '');
INSERT INTO `forums_lang_keys` VALUES (9, 17, '');
INSERT INTO `forums_lang_keys` VALUES (9, 18, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 19, '');
INSERT INTO `forums_lang_keys` VALUES (9, 20, '');
INSERT INTO `forums_lang_keys` VALUES (9, 21, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 22, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 23, '');
INSERT INTO `forums_lang_keys` VALUES (9, 24, '');
INSERT INTO `forums_lang_keys` VALUES (9, 25, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 26, '  ');
INSERT INTO `forums_lang_keys` VALUES (9, 27, '');
INSERT INTO `forums_lang_keys` VALUES (9, 28, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 29, '');
INSERT INTO `forums_lang_keys` VALUES (9, 30, ':');
INSERT INTO `forums_lang_keys` VALUES (9, 31, '                   ');
INSERT INTO `forums_lang_keys` VALUES (9, 32, '   ');
INSERT INTO `forums_lang_keys` VALUES (9, 33, '');
INSERT INTO `forums_lang_keys` VALUES (9, 34, '           ?    '''',   .');
INSERT INTO `forums_lang_keys` VALUES (9, 35, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 36, '...');
INSERT INTO `forums_lang_keys` VALUES (9, 37, '');
INSERT INTO `forums_lang_keys` VALUES (9, 38, '  ');
INSERT INTO `forums_lang_keys` VALUES (9, 39, '    :');
INSERT INTO `forums_lang_keys` VALUES (9, 40, '');
INSERT INTO `forums_lang_keys` VALUES (9, 41, '  ');
INSERT INTO `forums_lang_keys` VALUES (9, 42, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 43, '');
INSERT INTO `forums_lang_keys` VALUES (9, 44, 'E-mail:');
INSERT INTO `forums_lang_keys` VALUES (9, 45, '!');
INSERT INTO `forums_lang_keys` VALUES (9, 46, '     .      !');
INSERT INTO `forums_lang_keys` VALUES (9, 47, '2');
INSERT INTO `forums_lang_keys` VALUES (9, 48, '');
INSERT INTO `forums_lang_keys` VALUES (9, 49, '  2  ');
INSERT INTO `forums_lang_keys` VALUES (9, 50, '   ');
INSERT INTO `forums_lang_keys` VALUES (9, 51, '   ');
INSERT INTO `forums_lang_keys` VALUES (9, 52, '  ');
INSERT INTO `forums_lang_keys` VALUES (9, 53, ',  ');
INSERT INTO `forums_lang_keys` VALUES (9, 54, '');
INSERT INTO `forums_lang_keys` VALUES (9, 55, ' :');
INSERT INTO `forums_lang_keys` VALUES (9, 56, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 57, '    ');
INSERT INTO `forums_lang_keys` VALUES (9, 58, '');
INSERT INTO `forums_lang_keys` VALUES (9, 59, '');
INSERT INTO `forums_lang_keys` VALUES (9, 60, '');
INSERT INTO `forums_lang_keys` VALUES (9, 61, '');
INSERT INTO `forums_lang_keys` VALUES (9, 62, '  ');
INSERT INTO `forums_lang_keys` VALUES (9, 63, '   !');
INSERT INTO `forums_lang_keys` VALUES (9, 64, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 65, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 66, '!');
INSERT INTO `forums_lang_keys` VALUES (9, 67, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 68, '');
INSERT INTO `forums_lang_keys` VALUES (9, 69, '');
INSERT INTO `forums_lang_keys` VALUES (9, 70, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 71, '');
INSERT INTO `forums_lang_keys` VALUES (9, 72, '');
INSERT INTO `forums_lang_keys` VALUES (9, 73, '');
INSERT INTO `forums_lang_keys` VALUES (9, 74, '! (   )');
INSERT INTO `forums_lang_keys` VALUES (9, 75, '  ');
INSERT INTO `forums_lang_keys` VALUES (9, 76, ':  ');
INSERT INTO `forums_lang_keys` VALUES (9, 77, '  !');
INSERT INTO `forums_lang_keys` VALUES (9, 78, ':   ');
INSERT INTO `forums_lang_keys` VALUES (9, 79, ' !');
INSERT INTO `forums_lang_keys` VALUES (9, 80, '');
INSERT INTO `forums_lang_keys` VALUES (9, 81, '');
INSERT INTO `forums_lang_keys` VALUES (9, 82, ' ()');
INSERT INTO `forums_lang_keys` VALUES (9, 83, '  ');
INSERT INTO `forums_lang_keys` VALUES (9, 84, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 85, '  !');
INSERT INTO `forums_lang_keys` VALUES (9, 86, '      !');
INSERT INTO `forums_lang_keys` VALUES (9, 87, ' .');
INSERT INTO `forums_lang_keys` VALUES (9, 88, ',  ');
INSERT INTO `forums_lang_keys` VALUES (9, 89, '  () ');
INSERT INTO `forums_lang_keys` VALUES (9, 90, '');
INSERT INTO `forums_lang_keys` VALUES (9, 91, '');
INSERT INTO `forums_lang_keys` VALUES (9, 92, '');
INSERT INTO `forums_lang_keys` VALUES (9, 93, '');
INSERT INTO `forums_lang_keys` VALUES (9, 94, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 95, '');
INSERT INTO `forums_lang_keys` VALUES (9, 96, ' ,    ()');
INSERT INTO `forums_lang_keys` VALUES (9, 97, ' ()   (  )');
INSERT INTO `forums_lang_keys` VALUES (9, 98, '  () ');
INSERT INTO `forums_lang_keys` VALUES (9, 99, '--- !');
INSERT INTO `forums_lang_keys` VALUES (9, 100, '  :');
INSERT INTO `forums_lang_keys` VALUES (9, 101, '  :');
INSERT INTO `forums_lang_keys` VALUES (9, 102, '    :');
INSERT INTO `forums_lang_keys` VALUES (9, 103, ':      !');
INSERT INTO `forums_lang_keys` VALUES (9, 104, ' :');
INSERT INTO `forums_lang_keys` VALUES (9, 105, ' :');
INSERT INTO `forums_lang_keys` VALUES (9, 106, ' ?');
INSERT INTO `forums_lang_keys` VALUES (9, 107, ':  !');
INSERT INTO `forums_lang_keys` VALUES (9, 108, ':    !');
INSERT INTO `forums_lang_keys` VALUES (9, 109, ':         !');
INSERT INTO `forums_lang_keys` VALUES (9, 110, '  ');
INSERT INTO `forums_lang_keys` VALUES (9, 111, '  ');
INSERT INTO `forums_lang_keys` VALUES (9, 112, '  :');
INSERT INTO `forums_lang_keys` VALUES (9, 113, ' ( )?');
INSERT INTO `forums_lang_keys` VALUES (9, 114, '');
INSERT INTO `forums_lang_keys` VALUES (9, 115, '');
INSERT INTO `forums_lang_keys` VALUES (9, 116, ':      !');
INSERT INTO `forums_lang_keys` VALUES (9, 117, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 118, '  ');
INSERT INTO `forums_lang_keys` VALUES (9, 119, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 120, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 121, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 122, '');
INSERT INTO `forums_lang_keys` VALUES (9, 123, '');
INSERT INTO `forums_lang_keys` VALUES (9, 124, '');
INSERT INTO `forums_lang_keys` VALUES (9, 125, ',    .     ,   .      &quot;');
INSERT INTO `forums_lang_keys` VALUES (9, 126, '');
INSERT INTO `forums_lang_keys` VALUES (9, 127, '');
INSERT INTO `forums_lang_keys` VALUES (9, 128, '    ( ):');
INSERT INTO `forums_lang_keys` VALUES (9, 129, '  ');
INSERT INTO `forums_lang_keys` VALUES (9, 130, ',    :');
INSERT INTO `forums_lang_keys` VALUES (9, 131, '       ,     ');
INSERT INTO `forums_lang_keys` VALUES (9, 132, '');
INSERT INTO `forums_lang_keys` VALUES (9, 133, '');
INSERT INTO `forums_lang_keys` VALUES (9, 134, '  ');
INSERT INTO `forums_lang_keys` VALUES (9, 135, '  ');
INSERT INTO `forums_lang_keys` VALUES (9, 136, '   ');
INSERT INTO `forums_lang_keys` VALUES (9, 137, '');
INSERT INTO `forums_lang_keys` VALUES (9, 138, '  ');
INSERT INTO `forums_lang_keys` VALUES (9, 139, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 140, '');
INSERT INTO `forums_lang_keys` VALUES (9, 141, '');
INSERT INTO `forums_lang_keys` VALUES (9, 142, '   ');
INSERT INTO `forums_lang_keys` VALUES (9, 143, ' ,  ,   ,   ?');
INSERT INTO `forums_lang_keys` VALUES (9, 144, '     private ');
INSERT INTO `forums_lang_keys` VALUES (9, 145, '     ');
INSERT INTO `forums_lang_keys` VALUES (9, 146, '');
INSERT INTO `forums_lang_keys` VALUES (9, 147, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 148, '  ');
INSERT INTO `forums_lang_keys` VALUES (9, 149, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 150, '');
INSERT INTO `forums_lang_keys` VALUES (9, 151, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 152, '');
INSERT INTO `forums_lang_keys` VALUES (9, 153, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 154, '    ');
INSERT INTO `forums_lang_keys` VALUES (9, 155, '    !');
INSERT INTO `forums_lang_keys` VALUES (9, 156, '    :');
INSERT INTO `forums_lang_keys` VALUES (9, 157, '   ');
INSERT INTO `forums_lang_keys` VALUES (9, 158, '         ?');
INSERT INTO `forums_lang_keys` VALUES (9, 159, '   ');
INSERT INTO `forums_lang_keys` VALUES (9, 160, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 161, '');
INSERT INTO `forums_lang_keys` VALUES (9, 162, '');
INSERT INTO `forums_lang_keys` VALUES (9, 163, '');
INSERT INTO `forums_lang_keys` VALUES (9, 164, '   ');
INSERT INTO `forums_lang_keys` VALUES (9, 165, '  ');
INSERT INTO `forums_lang_keys` VALUES (9, 166, '');
INSERT INTO `forums_lang_keys` VALUES (9, 167, '');
INSERT INTO `forums_lang_keys` VALUES (9, 168, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 169, '!     .');
INSERT INTO `forums_lang_keys` VALUES (9, 170, '  ');
INSERT INTO `forums_lang_keys` VALUES (9, 171, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 172, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 173, ' .');
INSERT INTO `forums_lang_keys` VALUES (9, 174, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 175, '');
INSERT INTO `forums_lang_keys` VALUES (9, 176, '  ');
INSERT INTO `forums_lang_keys` VALUES (9, 177, '');
INSERT INTO `forums_lang_keys` VALUES (9, 178, ',    ');
INSERT INTO `forums_lang_keys` VALUES (9, 179, ',   ,      ,   ');
INSERT INTO `forums_lang_keys` VALUES (9, 180, '');
INSERT INTO `forums_lang_keys` VALUES (9, 181, '');
INSERT INTO `forums_lang_keys` VALUES (9, 182, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 183, '    ?');
INSERT INTO `forums_lang_keys` VALUES (9, 184, '     ');
INSERT INTO `forums_lang_keys` VALUES (9, 185, '');
INSERT INTO `forums_lang_keys` VALUES (9, 186, '  ()');
INSERT INTO `forums_lang_keys` VALUES (9, 187, '  ()');
INSERT INTO `forums_lang_keys` VALUES (9, 188, '');
INSERT INTO `forums_lang_keys` VALUES (9, 189, '');
INSERT INTO `forums_lang_keys` VALUES (9, 190, '');
INSERT INTO `forums_lang_keys` VALUES (9, 191, '');
INSERT INTO `forums_lang_keys` VALUES (9, 192, '+');
INSERT INTO `forums_lang_keys` VALUES (9, 193, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 194, '    ');
INSERT INTO `forums_lang_keys` VALUES (9, 195, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 196, '     ?');
INSERT INTO `forums_lang_keys` VALUES (9, 197, '');
INSERT INTO `forums_lang_keys` VALUES (9, 198, '');
INSERT INTO `forums_lang_keys` VALUES (9, 199, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 200, '');
INSERT INTO `forums_lang_keys` VALUES (9, 201, '');
INSERT INTO `forums_lang_keys` VALUES (9, 202, '');
INSERT INTO `forums_lang_keys` VALUES (9, 203, '');
INSERT INTO `forums_lang_keys` VALUES (9, 204, '  ');
INSERT INTO `forums_lang_keys` VALUES (9, 205, '');
INSERT INTO `forums_lang_keys` VALUES (9, 206, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 207, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 208, '');
INSERT INTO `forums_lang_keys` VALUES (9, 209, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 210, '');
INSERT INTO `forums_lang_keys` VALUES (9, 211, '');
INSERT INTO `forums_lang_keys` VALUES (9, 212, '');
INSERT INTO `forums_lang_keys` VALUES (9, 213, '');
INSERT INTO `forums_lang_keys` VALUES (9, 214, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 215, '');
INSERT INTO `forums_lang_keys` VALUES (9, 216, '  ');
INSERT INTO `forums_lang_keys` VALUES (9, 217, '  ');
INSERT INTO `forums_lang_keys` VALUES (9, 218, '');
INSERT INTO `forums_lang_keys` VALUES (9, 219, '');
INSERT INTO `forums_lang_keys` VALUES (9, 220, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 221, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 222, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 223, '  ');
INSERT INTO `forums_lang_keys` VALUES (9, 224, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 225, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 226, '  &quot; &quot;');
INSERT INTO `forums_lang_keys` VALUES (9, 227, '  ');
INSERT INTO `forums_lang_keys` VALUES (9, 228, '');
INSERT INTO `forums_lang_keys` VALUES (9, 229, '');
INSERT INTO `forums_lang_keys` VALUES (9, 230, '  , ');
INSERT INTO `forums_lang_keys` VALUES (9, 231, '   ');
INSERT INTO `forums_lang_keys` VALUES (9, 232, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 233, '?');
INSERT INTO `forums_lang_keys` VALUES (9, 234, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 235, '');
INSERT INTO `forums_lang_keys` VALUES (9, 236, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 237, ' ');
INSERT INTO `forums_lang_keys` VALUES (9, 238, ' :');
INSERT INTO `forums_lang_keys` VALUES (9, 239, ' :');
INSERT INTO `forums_lang_keys` VALUES (9, 240, '!    .');
INSERT INTO `forums_lang_keys` VALUES (9, 241, '    ');
INSERT INTO `forums_lang_keys` VALUES (9, 242, '    ');

-- --------------------------------------------------------

-- 
--   `forums_lang_translations`
-- 

CREATE TABLE `forums_lang_translations` (
  `id` int(6) NOT NULL auto_increment,
  `pseudo_id` int(6) default NULL,
  `zone_id` int(6) default NULL,
  `descr` mediumtext,
  `version` varchar(7) default NULL,
  `create_date` date default NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=10 ;

-- 
--    `forums_lang_translations`
-- 

INSERT INTO `forums_lang_translations` VALUES (1, 92, 1, 'Common english translation.', '2.0', '2006-10-20');
INSERT INTO `forums_lang_translations` VALUES (9, 92, 2, 'UTF-8 russian translation', '1.0', '2005-12-24');

-- --------------------------------------------------------

-- 
--   `forums_lang_zones`
-- 

CREATE TABLE `forums_lang_zones` (
  `id` int(6) NOT NULL auto_increment,
  `stitle` varchar(7) default NULL,
  `ftitle` varchar(63) default NULL,
  `user_id` int(6) default NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=18 ;

-- 
--    `forums_lang_zones`
-- 

INSERT INTO `forums_lang_zones` VALUES (1, 'EN', 'English', 0);
INSERT INTO `forums_lang_zones` VALUES (2, 'RU', 'Russian', 0);
INSERT INTO `forums_lang_zones` VALUES (3, 'DE', 'German', 0);
INSERT INTO `forums_lang_zones` VALUES (4, 'FR', 'French', 0);
INSERT INTO `forums_lang_zones` VALUES (17, 'CHI', 'Chinese', 1);

-- --------------------------------------------------------

-- 
--   `forums_messages`
-- 

CREATE TABLE `forums_messages` (
  `id` int(6) NOT NULL auto_increment,
  `pseudo_id` int(6) default NULL,
  `thread_id` int(6) default NULL,
  `header` mediumtext,
  `body` longtext,
  `created` datetime default NULL,
  `valid` enum('Y','N','P') default NULL,
  `already_read` enum('Y','N') default NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=191 ;

-- 
--    `forums_messages`
-- 

-- --------------------------------------------------------

-- 
--   `forums_pseudos`
-- 

CREATE TABLE `forums_pseudos` (
  `id` int(6) NOT NULL auto_increment,
  `user_id` int(6) default NULL,
  `name` varchar(255) default NULL,
  `comment` varchar(50) default NULL,
  `comment2` mediumtext,
  `create_date` date default NULL,
  `folder_id` int(6) default NULL,
  `can_invite` enum('Y','N') NOT NULL default 'Y',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=156 ;

-- 
--    `forums_pseudos`
-- 

INSERT INTO `forums_pseudos` VALUES (1, 0, 'Guest', 'Guest', 'Guest', '2000-01-01', 0, 'Y');
INSERT INTO `forums_pseudos` VALUES (92, 49, 'Admin', '', '', '2005-07-06', 210, 'Y');

-- --------------------------------------------------------

-- 
--   `forums_somesettings`
-- 

CREATE TABLE `forums_somesettings` (
  `user_id` int(6) unsigned NOT NULL auto_increment,
  `datinglink_ontop` enum('Y','N') default NULL,
  PRIMARY KEY  (`user_id`),
  UNIQUE KEY `user_id` (`user_id`),
  KEY `user_id_2` (`user_id`)
) TYPE=MyISAM AUTO_INCREMENT=90 ;

-- 
--    `forums_somesettings`
-- 

INSERT INTO `forums_somesettings` VALUES (53, 'Y');
INSERT INTO `forums_somesettings` VALUES (50, 'Y');
INSERT INTO `forums_somesettings` VALUES (66, 'Y');
INSERT INTO `forums_somesettings` VALUES (89, 'Y');

-- --------------------------------------------------------

-- 
--   `forums_subscribtions`
-- 

CREATE TABLE `forums_subscribtions` (
  `user_id` int(6) default NULL,
  `forum_id` int(6) default NULL
) TYPE=MyISAM;

-- 
--    `forums_subscribtions`
-- 

-- --------------------------------------------------------

-- 
--   `forums_threads`
-- 

CREATE TABLE `forums_threads` (
  `id` int(6) NOT NULL auto_increment,
  `name` varchar(255) default NULL,
  `forum_id` int(6) default NULL,
  `createdate` date default NULL,
  `hidden` enum('Y','N') default 'N',
  `link` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=39 ;

-- 
--    `forums_threads`
-- 

-- --------------------------------------------------------

-- 
--   `forums_threads_lastvisits`
-- 

CREATE TABLE `forums_threads_lastvisits` (
  `thread_id` int(6) default NULL,
  `user_id` int(6) default NULL,
  `when` datetime default NULL
) TYPE=MyISAM;

-- 
--    `forums_threads_lastvisits`
-- 

-- --------------------------------------------------------

-- 
--   `forums_users`
-- 

CREATE TABLE `forums_users` (
  `id` int(6) NOT NULL auto_increment,
  `login` varchar(255) default NULL,
  `pass` varchar(255) default NULL,
  `email` varchar(255) default NULL,
  `admin` enum('Y','N') default NULL,
  `trans_id` int(6) default NULL,
  `reg_date` date default NULL,
  `charset` int(6) unsigned default NULL,
  `secr_q` varchar(255) default NULL,
  `secr_a` varchar(255) default NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=111 ;

-- 
--    `forums_users`
-- 

INSERT INTO `forums_users` VALUES (49, 'admin', 'admin', 'escaper@php.by', 'Y', 1, '2005-07-06', 0, 'no question', '923h42foi4uf0');

-- --------------------------------------------------------

-- 
--   `wm_addressbook`
-- 

CREATE TABLE `wm_addressbook` (
  `id` int(11) NOT NULL auto_increment,
  `user_id` int(11) default NULL,
  `pseudo_id` int(11) default NULL,
  `email` varchar(200) default NULL,
  `comment` text,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=25 ;

-- 
--    `wm_addressbook`
-- 

-- --------------------------------------------------------

-- 
--   `wm_invitations`
-- 

CREATE TABLE `wm_invitations` (
  `id` int(11) NOT NULL auto_increment,
  `pseudo_id` int(11) default NULL,
  `pseudo_parent_id` int(11) default NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=5 ;

-- 
--    `wm_invitations`
-- 

-- --------------------------------------------------------

-- 
--   `wm_invited`
-- 

CREATE TABLE `wm_invited` (
  `id` int(11) NOT NULL auto_increment,
  `secretkey` varchar(128) default NULL,
  `pid` int(11) NOT NULL default '0',
  `email` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=5 ;

-- 
--    `wm_invited`
-- 

-- --------------------------------------------------------

-- 
--   `wm_invitemessages`
-- 

CREATE TABLE `wm_invitemessages` (
  `id` int(11) NOT NULL auto_increment,
  `invitetext` text,
  `lang` varchar(6) default NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=5 ;

-- 
--    `wm_invitemessages`
-- 

INSERT INTO `wm_invitemessages` VALUES (1, 'dear user, you are invited in trusted forum system, please push link below and enjoy!', 'en');
INSERT INTO `wm_invitemessages` VALUES (2, '&#1090;&#1088;&#1072;&#1089;&#1090;-&#1092;&#1086;&#1088;&#1091;&#1084; &#1088;&#1072;&#1076; &#1087;&#1088;&#1080;&#1074;&#1077;&#1090;&#1089;&#1090;&#1074;&#1086;&#1074;&#1072;&#1090;&#1100; &#1074;&#1072;&#1089; ! &#1089;&#1083;&#1077;&#1076;&#1091;&#1081;&#1090;&#1077; &#1089;&#1083;&#1077;&#1076;&#1091;&#1102;&#1097;&#1077;&#1081; &#1089;&#1089;&#1099;&#1083;&#1082;&#1077;, &#1080; &#1074;&#1099; &#1087;&#1086;&#1083;&#1091;&#1095;&#1080;&#1090;&#1077; &#1076;&#1086;&#1089;&#1090;&#1091;&#1087; &#1082; &#1085;&#1072;&#1096;&#1077;&#1084;&#1091; &#1092;&#1086;&#1088;&#1091;&#1084;&#1091;', 'ru');
INSERT INTO `wm_invitemessages` VALUES (3, 'cher utilisateur, vous ?s invit?u syst? de confiance de forum, poussez svp le lien ci-dessous et appr?ez !', 'fr');
INSERT INTO `wm_invitemessages` VALUES (4, 'de beste gebruiker, wordt u uitgenodigd aan vertrouwd op forumsysteem, te duwen gelieve hieronder verbinding en te geniet van!', 'de');

-- --------------------------------------------------------

-- 
--   `wm_problems`
-- 

CREATE TABLE `wm_problems` (
  `id` int(11) NOT NULL auto_increment,
  `pseudo_id` int(11) default NULL,
  `problem` longtext,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM AUTO_INCREMENT=37 ;

-- 
--    `wm_problems`
-- 
        