<?
/*
##################################################
#
#    TForum library
#    A part of Trust-Forum project
#    Copyright (C) 2005  www.php.by
#
#    This library is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 2.1 of the License, or (at your option) any later version.
#
#    This library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this library; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#    or mailto:  info@php.by
#
##################################################
*/

// input protection
error_reporting ('E_NONE');

function inp_protection($item, $key)
{
	if (is_array($item))
	{
		while (list($k, $v)=each($item))
		{
			$_GET[$key][$k]=addslashes(str_replace("'", "&#x27;", htmlspecialchars($v)));
		}
	}
	else
	{
		$_GET[$key]=addslashes(str_replace("'", "&#x27;", htmlspecialchars($item)));
	}
}

array_walk($_GET, 'inp_protection');
array_walk($_POST, 'inp_protection');


// preparations
require_once ('mainconfig.php');

if (!isset($_GET['action']))
{
	$_GET['action']='';
}

// SMARTY start

define('SMARTY_DIR', './lib/smarty/');
require (SMARTY_DIR.'Smarty.class.php');
$smarty=new Smarty;
$smarty->template_dir='./lib/templates_root/templates/';
$smarty->compile_dir='./lib/templates_root/templates_c/';
$smarty->config_dir='./lib/templates_root/configs/';
$smarty->cache_dir='./lib/templates_root/cahce/';

// DB start

require_once ('dbaccesses.class.php');
$odba=new DBAccesses;

// sessions

session_start ("finf");

/*	if ($_GET['action']=='registernew')
	{
			unset ($_SESSION['finf']) ;
	}
*/
/*	if(isset( $_SESSION['isUserLoggedIn'] )) if ( $_SESSION['isUserLoggedIn'] ) {
$_GET['function']='checkLocalLogin';
$_POST['function']='checkLocalLogin';
include_once("../gls/index.php");
} */

//print_r($_SESSION);die;

if ($_GET['action']=='logout')
{
	session_destroy();
	$_GET['action']='';
}

if ($_GET['action']=='login')
{
	$tryuserid=0;
	$i=$odba->rightlogin($_POST['login'], $_POST['psw'], $tryuserid);

	switch ($i)
	{
	case 0:
		session_register ("finf");
		$_SESSION['finf']['username']=/*$_SESSION['pseudo']=*/$_POST['login'];
		$_SESSION['finf']['userpass']=$_POST['psw'];
		$_SESSION['finf']['userid']=/*$_SESSION['uid']=$_SESSION['homeuid']=*/$tryuserid;

		//      $_SESSION['isUserLoggedIn'] = true;
		//      $_SESSION['homesite'] = "http://".$_SERVER['SERVER_NAME'];

		$_GET['action']='showfolder';
		$_GET['id']=$odba->getMB($_SESSION['finf']['userid']);
		break;
	case 1:
		$smarty->assign("LoginError", 1);
		break;
	case 2:
		$smarty->assign("LoginError", 2);
		break;
	}
}

// the BODY

$smarty->assign('ct', $odba->gettranslation(1));

if (session_is_registered("finf"))
{
	if ($_GET['action']=='usetrans')
	{
		$odba->settranslation4user($_SESSION['finf']['userid'], $_GET['id']);
		$_GET['action']='translations';
	}

	$smarty->assign('ct', $odba->gettranslation($odba->gettranslationindex4user($_SESSION['finf']['userid'])));
}

$smarty->display('header.tpl');

if (session_is_registered("finf"))
{
	if ($_GET['action']=='dating_view1params')
	{
		require_once ('datingaccess.class.php');
		$daa=new DatingAccesses($datrel);
		$aid=$daa->accountexists($_SESSION['finf']['userid']);
		$smarty->assign('criteria', $daa->getcriterianocases($odba->getuserlangzone($_SESSION['finf']['userid'])));
		$content=$daa->getparameter($aid, $_GET['id'], $odba->getuserlangzone($_SESSION['finf']['userid']));
		$smarty->assign('match', $content);
		$smarty->display('datingoneparam.tpl');
		$smarty->display('footer.tpl');
		die;
	}

	$smarty->assign('username', $_SESSION['finf']['username']);
	$smarty->assign('userid', $_SESSION['finf']['userid']);

	if (isset($_POST['datinglink_ontop_set']))
	{
		if (!isset($_POST['datinglink_ontop'])) $_POST['datinglink_ontop']='N';

		$odba->setusersomesettings($_SESSION['finf']['userid'], 'datinglink_ontop', (($_POST['datinglink_ontop']=='Y')?'Y':'N'));
	}

	$smarty->assign('somesettings', $odba->getusersomesettings($_SESSION['finf']['userid']));
	$smarty->assign('forums_index_mb', $odba->getMB($_SESSION['finf']['userid']));
	$smarty->display('usermenu.tpl');

	if (substr($_GET['action'], 0, 3)!='dat')
	{                                   //FORUMS START HERE :-)
		$smarty->assign('anonly3', false); //  

		if ($_GET['action']=='createsubfolder')
		{
			if (!$odba->createsubfolder($_SESSION['finf']['userid'], $_GET['id'], $_GET['name']))
			{
				$smarty->assign('alert', 1);
				$smarty->assign('s', $_GET['name']);
			}

			$_GET['action']='showfolder';
		}

		if ($_GET['action']=='deletefolderandmove')
		{
			$tempp=$odba->getrootfolder($_GET['id']);
			$odba->deletefolderandmove($_GET['id'], $_SESSION['finf']['userid']);
			$_GET['action']='showfolder';
			$_GET['id']=$tempp;
		}

		if ($_GET['action']=='deletefolderandresign')
		{
			$tempp=$odba->getrootfolder($_GET['id']);
			$odba->deletefolderandresign($_GET['id'], $_SESSION['finf']['userid']);
			$_GET['action']='showfolder';
			$_GET['id']=$tempp;
		}

		if ($_GET['action']=='renamefolder')
		{
			$odba->renamefolder($_GET['id'], $_GET['name']);
			$_GET['action']='showfolder';
		}

		if ($_GET['action']=='movefolder')
		{
			$odba->movefolder($_GET['id'], $_GET['toid']);
			$_GET['action']='showfolder';
		}

		$smarty->assign('folderslist', $odba->getfolderslist($_SESSION['finf']['userid']));
		$smarty->assign('folderslist1', $odba->getfolderslist1($_SESSION['finf']['userid']));
		$smarty->assign('folderslist2', $odba->getfolderslist2($_SESSION['finf']['userid']));

		$smarty->display('folderslist.tpl');
		$smarty->display('mainframe.tpl');

		if ($_GET['action']=='conf')
		{
			$smarty->display('conf.tpl');
		}

		if ($_GET['action']=='doremove_f')
		{
			$odba->moveforum_f($_GET['ids'], $_GET['toid'], $_GET['fromid']);
			$_GET['action']='showfolder';
			$_GET['id']=$_GET['fromid'];
		}

		if ($_GET['action']=='doremove')
		{
			$odba->moveforum($_GET['id'], $_GET['toid'], $_GET['fromid']);
			$_GET['action']='showfolder';
			$_GET['id']=$_GET['fromid'];
		}

		if ($_GET['action']=='createforumaccept')
		{
			if ($_POST['newname']=="")
			{
				$smarty->assign('alert', 2);
				$smarty->assign('wasname', $_POST['newname']);
				$smarty->assign('waspseudoid', $_POST['_pseudoid']);
				$smarty->assign('wasfolderid', $_POST['_folderid']);
				$smarty->assign('wascom', $_POST['_com']);
				$smarty->assign('wascom2', $_POST['_com2']);
				$_GET['action']='createforumform';
			}
			elseif (!$odba->forumexists($_POST['newname']))
			{
				$_GET['id']=$odba->createforum($_SESSION['finf']['userid'], $_POST['newname'], $_POST['_pseudoid'], $_POST['_folderid'], $_POST['_com'], $_POST['_com2']);
				$odba->subscribe($_GET['id'], $_SESSION['finf']['userid']);
				$_GET['action']='showforum';
			}
			else
			{
				$smarty->assign('alert', 1);
				$smarty->assign('wasname', $_POST['newname']);
				$smarty->assign('waspseudoid', $_POST['_pseudoid']);
				$smarty->assign('wasfolderid', $_POST['_folderid']);
				$smarty->assign('wascom', $_POST['_com']);
				$smarty->assign('wascom2', $_POST['_com2']);
				$_GET['action']='createforumform';
			}
		}

		if ($_GET['action']=='createforumform')
		{
			$smarty->assign('pseudoslist', $odba->getpseudoslist($_SESSION['finf']['userid']));
			$smarty->display('createforum.tpl');
		}

		if ($_GET['action']=='subscribe_f')
		{
			$odba->subscribe_f($_POST, $_SESSION['finf']['userid'], $_POST['y']==1);
			$_GET['action']='showfolder';
			$_GET['id']=$_GET['fid'];
		}

		if ($_GET['action']=='customrenameforum')
		{
			$odba->customrenameforum($_GET['id'], $_GET['newname'], $_SESSION['finf']['userid']);
			$_GET['action']='showfolder';
			$_GET['id']=$odba->forum2folder($_GET['id'], $_SESSION['finf']['userid']);
		}

		if ($_GET['action']=='showfolder')
		{
			$tempfl=$odba->getforumslist($_SESSION['finf']['userid'], $_GET['id']);
			$smarty->assign('forumslist', $tempfl['a']);
			$smarty->assign('newamount', $tempfl['new']);
			$smarty->assign('subscribed', $tempfl['subs']);
			$smarty->assign('renames', $tempfl['renames']);
			$smarty->assign('members', $tempfl['members']);
			$smarty->assign('cc', 0);
			$smarty->assign('folderid', $_GET['id']);
			$smarty->assign('foldername', $odba->getfoldernamebyid($_GET['id']));
			$smarty->assign('candeleteit', $odba->folderdeletable($_GET['id']));
			$smarty->assign('isdatingfolder', $odba->isdatingfolder($_GET['id']));
			$smarty->assign('folderispub', $odba->folderispub($_GET['id']));
			$smarty->assign('folderslist1excepted', $odba->getfolderslist1excepted($_SESSION['finf']['userid'], $_GET['id']));
			$smarty->assign('folderslist2excepted', $odba->getfolderslist2excepted($_SESSION['finf']['userid'], $_GET['id']));
			$smarty->display('folderactions.tpl');
			$smarty->assign('place', $odba->placefolder($_GET['id']));
			$smarty->display('showforums.tpl');
		}

		if ($_GET['action']=='renamethread')
		{
			$odba->renamethread($_GET['id'], $_GET['newname']);
			$_GET['action']='showforum';
			$_GET['id']=$_GET['forumid'];
		}

		if ($_GET['action']=='addnewthread')
		{
			$odba->addnewthread($_GET['id'], $_GET['newname']);
			$_GET['action']='showforum';
		}

		if ($_GET['action']=='deletethread')
		{
			$odba->deletethread($_GET['id']);
			$_GET['action']='showforum';
			$_GET['id']=$_GET['forumid'];
		}

		if ($_GET['action']=='commonsettings')
		{
			$smarty->display('conf.tpl');
			$smarty->display('commonsettings.tpl');
		}

		if ($_GET['action']=='adminrenameforum')
		{
			$odba->adminrenameforum($_GET['id'], $_GET['newname']);
			$_GET['action']='showforum';
		}

		if ($_GET['action']=='adminrenamethread')
		{
			$odba->adminrenamethread($_GET['id'], $_GET['newname']);
			$_GET['action']='showforum';
			$_GET['id']=$odba->thread2forum($_GET['id']);
		}

		if ($_GET['action']=='resign')
		{
			if (!$odba->resign($_GET['forumid'], $_GET['pseudoid'], $_SESSION['finf']['userid']))
			{
				$smarty->assign('alert', 5);
			}

			$_GET['action']='showforum';
			$_GET['id']=$_GET['forumid'];
		}
		
		if ($_GET['action']=='changeperm')
		{
			if (!$odba->changeperm($_GET['forumid'], $_GET['pseudoid'], $_GET['new'], $_SESSION['finf']['userid']))
			{
				$smarty->assign('alert', 4);
			}

			if ($odba->isresign($_GET['pseudoid'], $_GET['new'], $_SESSION['finf']['userid'])) $_GET['action']='showforum';
			else $_GET['action']='editrights';
			$_GET['id']=$_GET['forumid'];
		}

		if ($_GET['action']=='showforum')
		{
			if ($odba->threadsexist($_GET['id']))
			{
				$tlist=$odba->getthreadslist($_GET['id'], $_SESSION['finf']['userid']);
				$smarty->assign('threadslist', $tlist['a']);
				$smarty->assign('newamount', $tlist['new']);
				$smarty->assign('adminallowed', 'Y');
				$smarty->assign('forumid', $_GET['id']);
				$smarty->assign('currentrights', $odba->getrights($_SESSION['finf']['userid'], $_GET['id']));
				$smarty->assign('canviewinv', $odba->canviewinv($_SESSION['finf']['userid'], $smarty->get_template_vars('forumid'), $smarty->get_template_vars('currentrights')));
				$smarty->assign('forumpub', $odba->forumispub($_GET['id']));
				$smarty->assign('place1', $odba->placefolder($odba->forum2folder($_GET['id'], $_SESSION['finf']['userid'])));
				$smarty->assign('place2', $odba->placeforum($_GET['id'], $_SESSION['finf']['userid']));
				$smarty->assign('place4', $odba->placecomment($_GET['id']));
				$smarty->display('showthreads.tpl');
			}
			else
			{
				$smarty->assign('oldmessage', 'false');
				$smarty->assign('status', 'no');
				$smarty->assign('messageslist', $odba->getmessageslist($odba->getanonlythreadindex($_GET['id']), $_SESSION['finf']['userid']));
				$smarty->assign('currentuser', $_SESSION['finf']['userid']);
				$smarty->assign('threadid', $odba->getanonlythreadindex($_GET['id']));
				$smarty->assign('pseudoslist', $odba->getpseudoslist($_SESSION['finf']['userid']));
				$smarty->assign('currentrights', $odba->getrights($_SESSION['finf']['userid'], $_GET['id']));
				$smarty->assign('forumid', $_GET['id']);
				$smarty->assign('canviewinv', $odba->canviewinv($_SESSION['finf']['userid'], $smarty->get_template_vars('forumid'), $smarty->get_template_vars('currentrights')));
				$smarty->assign('forumpub', $odba->forumispub($_GET['id']));
				$smarty->assign('place1', $odba->placefolder($odba->forum2folder($_GET['id'], $_SESSION['finf']['userid'])));
				$smarty->assign('place2', $odba->placeforum($_GET['id'], $_SESSION['finf']['userid']));
				$smarty->assign('place4', $odba->placecomment($_GET['id']));
				$smarty->assign('contactlist', $odba->getcontactlist($_SESSION['finf']['userid']));
				$smarty->assign('pseudosrights', $odba->getpseudosrights($_SESSION['finf']['userid'], $_GET['id']));
				$smarty->assign('only1thread', !$odba->threadsexist($smarty->get_template_vars('forumid')));
				$smarty->assign('place3', $odba->placethread($smarty->get_template_vars('threadid')));
				$smarty->assign('threadlink', $odba->getthreadlink($smarty->get_template_vars('threadid')));
				$smarty->display('showmessages.tpl');
			}
		}

		if ($_GET['action']=='showthread')
		{
			$smarty->assign('oldmessage', 'false');
			$smarty->assign('status', 'no');
			$smarty->assign('messageslist', $odba->getmessageslist($_GET['id'], $_SESSION['finf']['userid']));
			$smarty->assign('threadid', $_GET['id']);
			$smarty->assign('currentuser', $_SESSION['finf']['userid']);
			$smarty->assign('pseudoslist', $odba->getpseudoslist($_SESSION['finf']['userid']));
			$smarty->assign('forumid', $odba->thread2forum($_GET['id']));
			$smarty->assign('currentrights', $odba->getrights($_SESSION['finf']['userid'], $odba->thread2forum($_GET['id'])));
			$smarty->assign('canviewinv', $odba->canviewinv($_SESSION['finf']['userid'], $smarty->get_template_vars('forumid'), $smarty->get_template_vars('currentrights')));
			$smarty->assign('forumpub', $odba->forumispub($odba->thread2forum($_GET['id'])));
			$smarty->assign('place1', $odba->placefolder($odba->forum2folder($odba->thread2forum($_GET['id']), $_SESSION['finf']['userid'])));
			$smarty->assign('place2', $odba->placeforum($odba->thread2forum($_GET['id']), $_SESSION['finf']['userid']));
			$smarty->assign('place4', $odba->placecomment($odba->thread2forum($_GET['id'])));
			$smarty->assign('contactlist', $odba->getcontactlist($_SESSION['finf']['userid']));
			$smarty->assign('pseudosrights', $odba->getpseudosrights($_SESSION['finf']['userid'], $odba->thread2forum($_GET['id'])));
			$smarty->assign('place3', $odba->placethread($smarty->get_template_vars('threadid')));
			$smarty->assign('only1thread', !$odba->threadsexist($smarty->get_template_vars('forumid')));
			$smarty->assign('threadlink', $odba->getthreadlink($smarty->get_template_vars('threadid')));
			$smarty->display('showmessages.tpl');
		}

		if ($_GET['action']=='markvalid')
		{
			if ($odba->isnewmessage($_GET['id']) && !isset($_GET['proceed'])) $oldmessage='true';
			else
			{
				$oldmessage='false';
				$odba->markvalid($_SESSION['finf']['userid'], $_GET['id']);
			}
			$smarty->assign('oldmessage', $oldmessage);
			$smarty->assign('status', 'no');
			$smarty->assign('messageslist', $odba->getmessageslist($odba->message2thread($_GET['id']), $_SESSION['finf']['userid']));
			$smarty->assign('currentuser', $_SESSION['finf']['userid']);
			$smarty->assign('threadid', $odba->message2thread($_GET['id']));
			$smarty->assign('pseudoslist', $odba->getpseudoslist($_SESSION['finf']['userid']));
			$smarty->assign('forumid', $odba->thread2forum($odba->message2thread($_GET['id'])));
			$smarty->assign('currentrights', $odba->getrights($_SESSION['finf']['userid'], $odba->thread2forum($odba->message2thread($_GET['id']))));
			$smarty->assign('canviewinv', $odba->canviewinv($_SESSION['finf']['userid'], $smarty->get_template_vars('forumid'), $smarty->get_template_vars('currentrights')));
			$smarty->assign('forumpub', $odba->forumispub($odba->thread2forum($odba->message2thread($_GET['id']))));
			$smarty->assign('place1', $odba->placefolder($odba->forum2folder($odba->thread2forum($odba->message2thread($_GET['id'])), $_SESSION['finf']['userid'])));
			$smarty->assign('place2', $odba->placeforum($odba->thread2forum($odba->message2thread($_GET['id'])), $_SESSION['finf']['userid']));
			$smarty->assign('place4', $odba->placecomment($odba->thread2forum($odba->message2thread($_GET['id']))));
			$smarty->assign('contactlist', $odba->getcontactlist($_SESSION['finf']['userid']));
			$smarty->assign('pseudosrights', $odba->getpseudosrights($_SESSION['finf']['userid'], $odba->thread2forum($odba->message2thread($_GET['id']))));
			$smarty->assign('place3', $odba->placethread($smarty->get_template_vars('threadid')));
			$smarty->assign('only1thread', !$odba->threadsexist($smarty->get_template_vars('forumid')));
			$smarty->assign('threadlink', $odba->getthreadlink($smarty->get_template_vars('threadid')));
			$smarty->display('showmessages.tpl');
		}

		if ($_GET['action']=='resigninv')
		{
			$foldid=$odba->forum2folder($odba->thread2forum($_GET['id']), $_SESSION['finf']['userid']);
			$odba->resigninv($_SESSION['finf']['userid'], $odba->thread2forum($_GET['id']));
			$tempfl=$odba->getforumslist($_SESSION['finf']['userid'], $foldid);
			$smarty->assign('forumslist', $tempfl['a']);
			$smarty->assign('newamount', $tempfl['new']);
			$smarty->assign('subscribed', $tempfl['subs']);
			$smarty->assign('folderid', $foldid);
			$smarty->assign('renames', $tempfl['renames']);
			$smarty->assign('members', $tempfl['members']);
			$smarty->assign('candeleteit', $odba->folderdeletable($foldid));
			$smarty->assign('folderispub', $odba->folderispub($foldid));
			$smarty->assign('folderslist1excepted', $odba->getfolderslist1excepted($_SESSION['finf']['userid'], $foldid));
			$smarty->assign('folderslist2excepted', $odba->getfolderslist2excepted($_SESSION['finf']['userid'], $foldid));
			$smarty->display('folderactions.tpl');
			$smarty->assign('place', $odba->placefolder($foldid));
			$smarty->assign('foldername', $odba->getfoldernamebyid($foldid));
			$smarty->display('showforums.tpl');
		}

		if ($_GET['action']=='resigninvbyfid')
		{
			$foldid=$odba->forum2folder($_GET['id'], $_SESSION['finf']['userid']);
			$odba->resigninv($_SESSION['finf']['userid'], $_GET['id']);
			$tempfl=$odba->getforumslist($_SESSION['finf']['userid'], $foldid);
			$smarty->assign('forumslist', $tempfl['a']);
			$smarty->assign('newamount', $tempfl['new']);
			$smarty->assign('subscribed', $tempfl['subs']);
			$smarty->assign('renames', $tempfl['renames']);
			$smarty->assign('members', $tempfl['members']);
			$smarty->assign('folderid', $foldid);
			$smarty->assign('candeleteit', $odba->folderdeletable($foldid));
			$smarty->assign('folderispub', $odba->folderispub($foldid));
			$smarty->assign('folderslist1excepted', $odba->getfolderslist1excepted($_SESSION['finf']['userid'], $foldid));
			$smarty->assign('folderslist2excepted', $odba->getfolderslist2excepted($_SESSION['finf']['userid'], $foldid));
			$smarty->display('folderactions.tpl');
			$smarty->assign('place', $odba->placefolder($foldid));
			$smarty->assign('foldername', $odba->getfoldernamebyid($foldid));
			$smarty->display('showforums.tpl');
		}

		if ($_GET['action']=='markinvalid')
		{
			$odba->markinvalid($_SESSION['finf']['userid'], $_GET['id']);
			$smarty->assign('oldmessage', 'false');
			$smarty->assign('status', 'no');
			$smarty->assign('currentrights', $odba->getrights($_SESSION['finf']['userid'], $odba->thread2forum($odba->message2thread($_GET['id']))));
			$smarty->assign('messageslist', $odba->getmessageslist($odba->message2thread($_GET['id']), $_SESSION['finf']['userid']));
			$smarty->assign('threadid', $odba->message2thread($_GET['id']));
			$smarty->assign('currentuser', $_SESSION['finf']['userid']);
			$smarty->assign('pseudoslist', $odba->getpseudoslist($_SESSION['finf']['userid']));
			$smarty->assign('forumid', $odba->thread2forum($odba->message2thread($_GET['id'])));
			$smarty->assign('canviewinv', $odba->canviewinv($_SESSION['finf']['userid'], $smarty->get_template_vars('forumid'), $smarty->get_template_vars('currentrights')));
			$smarty->assign('forumpub', $odba->forumispub($odba->thread2forum($odba->message2thread($_GET['id']))));
			$smarty->assign('place1', $odba->placefolder($odba->forum2folder($odba->thread2forum($odba->message2thread($_GET['id'])), $_SESSION['finf']['userid'])));
			$smarty->assign('place2', $odba->placeforum($odba->thread2forum($odba->message2thread($_GET['id'])), $_SESSION['finf']['userid']));
			$smarty->assign('place4', $odba->placecomment($odba->thread2forum($odba->message2thread($_GET['id']))));
			$smarty->assign('contactlist', $odba->getcontactlist($_SESSION['finf']['userid']));
			$smarty->assign('pseudosrights', $odba->getpseudosrights($_SESSION['finf']['userid'], $odba->thread2forum($odba->message2thread($_GET['id']))));
			$smarty->assign('place3', $odba->placethread($smarty->get_template_vars('threadid')));
			$smarty->assign('only1thread', !$odba->threadsexist($smarty->get_template_vars('forumid')));
			$smarty->assign('threadlink', $odba->getthreadlink($smarty->get_template_vars('threadid')));
			$smarty->display('showmessages.tpl');
		}

		if ($_GET['action']=='erasemessage')
		{
			$threadid=$odba->message2thread($_GET['id']);
			$smarty->assign('oldmessage', 'false');
			$smarty->assign('status', 'no');
			$smarty->assign('currentrights', $rights=$odba->getrights($_SESSION['finf']['userid'], $odba->thread2forum($threadid)));
			$smarty->assign('forumid', $odba->thread2forum($odba->message2thread($_GET['id'])));
			$smarty->assign('threadid', $threadid);
			$odba->erasemessage($_SESSION['finf']['userid'], $_GET['id'], $rights);
			$smarty->assign('messageslist', $odba->getmessageslist($threadid, $_SESSION['finf']['userid']));
			$smarty->assign('currentuser', $_SESSION['finf']['userid']);
			$smarty->assign('pseudoslist', $odba->getpseudoslist($_SESSION['finf']['userid']));
			$smarty->assign('canviewinv', $odba->canviewinv($_SESSION['finf']['userid'], $smarty->get_template_vars('forumid'), $smarty->get_template_vars('currentrights')));
			$smarty->assign('forumpub', $odba->forumispub($odba->thread2forum($threadid)));
			$smarty->assign('place1', $odba->placefolder($odba->forum2folder($odba->thread2forum($threadid), $_SESSION['finf']['userid'])));
			$smarty->assign('place2', $odba->placeforum($odba->thread2forum($threadid), $_SESSION['finf']['userid']));
			$smarty->assign('place4', $odba->placecomment($odba->thread2forum($threadid)));
			$smarty->assign('contactlist', $odba->getcontactlist($_SESSION['finf']['userid']));
			$smarty->assign('pseudosrights', $odba->getpseudosrights($_SESSION['finf']['userid'], $odba->thread2forum($threadid)));
			$smarty->assign('place3', $odba->placethread($smarty->get_template_vars('threadid')));
			$smarty->assign('only1thread', !$odba->threadsexist($smarty->get_template_vars('forumid')));
			$smarty->assign('threadlink', $odba->getthreadlink($smarty->get_template_vars('threadid')));
			$smarty->display('showmessages.tpl');
		}

		if ($_GET['action']=='newreply')
		{
			$oldmessage='false';
			if (isset($_POST['no'])) $a='no';
			elseif (isset($_POST['yes']))
			{
				if ($odba->isnewmessage($_POST['lastmessageid']))
				{
					$a='preview';
					$oldmessage='true';
				} else
				{
					$a='yes';
				}
			}
			elseif (isset($_POST['preview']))
			{
				$a='preview';
			}
			else
			{
				$a='no_val';
			}
			
			$odba->newreply($_GET['id'], $_POST['_pseudoid'], $_POST['_title'], $_POST['_body'], $a);
			$smarty->assign('oldmessage', $oldmessage);
			$smarty->assign('status', $a);
			$smarty->assign('messageslist', $odba->getmessageslist($_GET['id'], $_SESSION['finf']['userid']));
			$smarty->assign('threadid', $_GET['id']);
			$smarty->assign('forumid', $odba->thread2forum($_GET['id']));
			$smarty->assign('currentuser', $_SESSION['finf']['userid']);
			$smarty->assign('pseudoslist', $odba->getpseudoslist($_SESSION['finf']['userid']));
			$smarty->assign('currentrights', $odba->getrights($_SESSION['finf']['userid'], $odba->thread2forum($_GET['id'])));
			$smarty->assign('canviewinv', $odba->canviewinv($_SESSION['finf']['userid'], $smarty->get_template_vars('forumid'), $smarty->get_template_vars('currentrights')));
			$smarty->assign('forumpub', $odba->forumispub($odba->thread2forum($_GET['id'])));
			$smarty->assign('place1', $odba->placefolder($odba->forum2folder($odba->thread2forum($_GET['id']), $_SESSION['finf']['userid'])));
			$smarty->assign('place2', $odba->placeforum($odba->thread2forum($_GET['id']), $_SESSION['finf']['userid']));
			$smarty->assign('place4', $odba->placecomment($odba->thread2forum($_GET['id'])));
			$smarty->assign('contactlist', $odba->getcontactlist($_SESSION['finf']['userid']));
			$smarty->assign('pseudosrights', $odba->getpseudosrights($_SESSION['finf']['userid'], $odba->thread2forum($_GET['id'])));
			$smarty->assign('place3', $odba->placethread($smarty->get_template_vars('threadid')));
			$smarty->assign('only1thread', !$odba->threadsexist($smarty->get_template_vars('forumid')));
			$smarty->assign('threadlink', $odba->getthreadlink($smarty->get_template_vars('threadid')));
			$smarty->display('showmessages.tpl');
		}

		if ($_GET['action']=='editmessage')
		{
			$smarty->assign('mid', $_GET['id']);
			$smarty->assign('wastext', $odba->getmessagetext($_GET['id']));
			$smarty->display('editmessage.tpl');
		}

		if ($_GET['action']=='doeditmessage')
		{
			$oldmessage='false';
			if (isset($_POST['no'])) $a='no';
			elseif (isset($_POST['yes']))
			{
				if ($odba->isnewmessage($_POST['lastmessageid']))
				{
					$a='preview';
					$oldmessage='true';
				} else
				{
					$a='yes';
				}
			}
			elseif (isset($_POST['preview'])) $a='preview';
			else
			{
				$a='no_val';
			}
			
			$odba->editmessage($_GET['id'], $_POST['newtext'], $_POST['newtitle'], $a);
			$_GET['id']=$odba->message2thread($_GET['id']);
			$smarty->assign('oldmessage', $oldmessage);
			$smarty->assign('status', $a);
			$smarty->assign('messageslist', $odba->getmessageslist($_GET['id'], $_SESSION['finf']['userid']));
			$smarty->assign('threadid', $_GET['id']);
			$smarty->assign('forumid', $odba->thread2forum($_GET['id']));
			$smarty->assign('currentuser', $_SESSION['finf']['userid']);
			$smarty->assign('pseudoslist', $odba->getpseudoslist($_SESSION['finf']['userid']));
			$smarty->assign('currentrights', $odba->getrights($_SESSION['finf']['userid'], $odba->thread2forum($_GET['id'])));
			$smarty->assign('canviewinv', $odba->canviewinv($_SESSION['finf']['userid'], $smarty->get_template_vars('forumid'), $smarty->get_template_vars('currentrights')));
			$smarty->assign('forumpub', $odba->forumispub($odba->thread2forum($_GET['id'])));
			$smarty->assign('place1', $odba->placefolder($odba->forum2folder($odba->thread2forum($_GET['id']), $_SESSION['finf']['userid'])));
			$smarty->assign('place2', $odba->placeforum($odba->thread2forum($_GET['id']), $_SESSION['finf']['userid']));
			$smarty->assign('place4', $odba->placecomment($odba->thread2forum($_GET['id'])));
			$smarty->assign('contactlist', $odba->getcontactlist($_SESSION['finf']['userid']));
			$smarty->assign('pseudosrights', $odba->getpseudosrights($_SESSION['finf']['userid'], $odba->thread2forum($_GET['id'])));
			$smarty->assign('place3', $odba->placethread($smarty->get_template_vars('threadid')));
			$smarty->assign('only1thread', !$odba->threadsexist($smarty->get_template_vars('forumid')));
			$smarty->assign('threadlink', $odba->getthreadlink($smarty->get_template_vars('threadid')));
			$smarty->display('showmessages.tpl');
		}

		//*-*-*-*-*-*-*-*-*-*-*-*-*-**-*-*-*-*-*-*-*-*-*-**-configs started!!

		if ($_GET['action']=='removepseudo')
		{
			$odba->removepseudo($_GET['id']);
			$_GET['action']='mypseudos';
		}

		if ($_GET['action']=='newpseudo')
		{
			if (!$odba->newpseudo($_POST['pname'], $_POST['pcomment'], $_POST['pcomment2'], $_SESSION['finf']['userid']))
			{
				$smarty->assign('alert', 1);
				$_GET['action']='regnewpseudo';
			}
			else $_GET['action']='mypseudos';
		}

		if ($_GET['action']=='regnewpseudo')
		{
			$smarty->assign('regnew', 'Y');
			$smarty->display('pseudosettings.tpl');
		}

		if ($_GET['action']=='editpseudo')
		{
			$smarty->assign('regnew', 'N');
			$smarty->assign('pdata', $odba->getpseudodata($_GET['id']));
			$smarty->display('pseudosettings.tpl');
		}

		if ($_GET['action']=='doeditpseudo')
		{
			$odba->changepseudocomment($_POST['pid'], $_POST['pcomment']);
			$odba->changepseudocomment2($_POST['pid'], $_POST['pcomment2']);
			$_GET['action']='mypseudos';
		}

		if ($_GET['action']=='setpseudofolder')
		{
			$odba->setpseudofolder($_GET['id'], $_GET['fid']);
			$_GET['action']='mypseudos';
		}

		if ($_GET['action']=='mypseudos')
		{
			$smarty->assign('pseudoslist4user', $odba->getpseudoslist4user($_SESSION['finf']['userid']));
			$smarty->assign('folderslist', $odba->getfolderslist1($_SESSION['finf']['userid']));
			$smarty->assign('pseudosfolders', $odba->getpseudosfolders($_SESSION['finf']['userid']));
			$smarty->display('conf.tpl');
			$smarty->display('mypseudos.tpl');
		}

		if ($_GET['action']=='viewpseudo')
		{
			$smarty->assign('pseudodata', $odba->getpseudodata($_GET['id']));
			$smarty->assign('privforumslistofpseudo', $odba->getprivforumslistofpseudo($_GET['id'], $_SESSION['finf']['userid']));
			$smarty->assign('canadd', $odba->canadd($_SESSION['finf']['userid'], $_GET['id']));
			$smarty->display('viewpseudo.tpl');
		}

		if ($_GET['action']=='newperm')
		{
			if ($_POST['CLpseudoid']==-1)
			{
				if (!($odba->pseudoexists($_POST['newpseudo'])))
				{
					$smarty->assign('alert', 1);
					$smarty->assign('s', $_POST['newpseudo']);
				}
				else
				{
					if (!($odba->newperm($_GET['forumid'], $_POST['newpseudo'], $_POST['new'], $_POST['PWIid'])))
					{
						$smarty->assign('alert', 2);
						$smarty->assign('s', $_POST['newpseudo']);
					}
					else
					{
						$smarty->assign('alert', 0);
					}
				}
			}
			else
			{
				if (!($odba->newpermbypid($_GET['forumid'], $_POST['CLpseudoid'], $_POST['new'], $_POST['PWIid'])))
				{
					$smarty->assign('alert', 2);
					$smarty->assign('s', $odba->getpseudobyid($_POST['CLpseudoid']));
				}
				else
				{
					$smarty->assign('alert', 0);
				}
			}

			$_GET['action']='editrights';
			$_GET['id']=$_GET['forumid'];
		}

		if ($_GET['action']=='changepubBL')
		{
			$odba->changepubbl($_GET['forumid'], $_GET['pseudoid'], $_GET['new']);
			$_GET['action']='editrights';
			$_GET['id']=$_GET['forumid'];

			if (($_GET['new']=='r')&&($_GET['pseudoid']==1))
			{
				$smarty->assign('alert', 3);
			}
		}

		if ($_GET['action']=='newpubBL')
		{
			if ($_POST['CLpseudoid']==-1)
			{
				if (!($odba->pseudoexists($_POST['newpseudo'])))
				{
					$smarty->assign('alert', 1);
					$smarty->assign('s', $_POST['newpseudo']);
				}
				else
				{
					if (!($odba->addpubbl($_GET['forumid'], $_POST['newpseudo'], $_POST['new'], $_POST['PWIid'])))
					{
						$smarty->assign('alert', 2);
						$smarty->assign('s', $_POST['newpseudo']);
					}
					else
					{
						$smarty->assign('alert', 0);
					}
				}
			}
			else
			{
				if (!($odba->addpubblbyid($_GET['forumid'], $_POST['CLpseudoid'], $_POST['new'], $_POST['PWIid'])))
				{
					$smarty->assign('alert', 2);
					$smarty->assign('s', $odba->getpseudobyid($_POST['CLpseudoid']));
				}
				else
				{
					$smarty->assign('alert', 0);
				}
			}

			$_GET['action']='editrights';
			$_GET['id']=$_GET['forumid'];
		}

/*old one		if ($_GET['action']=='newpubBL')
		{
			if ($_POST['CLpseudoid0']==-1)
			{
				if (!($odba->pseudoexists($_POST['newpseudo'])))
				{
					$smarty->assign('alert', 1);
					$smarty->assign('s', $_POST['newpseudo']);
				}
				else
				{
					if (!($odba->addpubbl($_GET['forumid'], $_POST['newpseudo'], $_POST['new'])))
					{
						$smarty->assign('alert', 2);
						$smarty->assign('s', $_POST['newpseudo']);
					}
					else
					{
						$smarty->assign('alert', 0);
					}

					if ((strtolower($_POST['newpseudo'])=='guest')&&($_POST['new']=='r'))
					{
						$smarty->assign('alert', 3);
					}
				}
			}
			else
			{
				if (!($odba->addpubblbyid($_GET['forumid'], $_POST['CLpseudoid0'], $_POST['new'])))
				{
					$smarty->assign('alert', 2);
					$smarty->assign('s', $odba->getpseudobyid($_POST['CLpseudoid0']));
				}
				else
				{
					$smarty->assign('alert', 0);
				}

				if ((strtolower($odba->getpseudobyid($_POST['CLpseudoid0']))=='guest')&&($_POST['new']=='r'))
				{
					$smarty->assign('alert', 3);
				}
			}

			$_GET['action']='editrights';
			$_GET['id']=$_GET['forumid'];
		} */

		if ($_GET['action']=='setviewinvaccess')
		{
			$odba->setviewinvaccess($_GET['id'], $_GET['pid'], $_GET['new']);
			$_GET['action']='editrights';
		}

		if ($_GET['action']=='editrights')
		{
			$smarty->assign('forumid', $_GET['id']);
			$smarty->assign('rightslist', $odba->getrightslist($_GET['id']));
			$smarty->assign('pub', $odba->forumispub($_GET['id'])); //    Y / N
			$smarty->assign('pseudoslist', $odba->getpseudoslist($_SESSION['finf']['userid']));
			$smarty->assign('pseudosrights', $odba->getpseudosrights($_SESSION['finf']['userid'], $_GET['id']));
			$smarty->assign('contactlist', $odba->getcontactlist($_SESSION['finf']['userid']));
			$smarty->assign('forumname', $odba->placeforum($_GET['id'], $_SESSION['finf']['userid']));
			$smarty->display('editrights.tpl');
		}

		if ($_GET['action']=='newemailinvitation')
		{
			if ($_POST['CLemailid']==-1)
			{
				if (($odba->emailexists($_POST['newemail'], $_GET['forumid'])))
				{
					$smarty->assign('alert', 2);
					$smarty->assign('s', $_POST['newemail']);
				}
				else
				{
					$langzone = $odba->getuserlangzone($_SESSION['finf']['userid']);
					$link = $odba->addinvitation($_GET['forumid'], $_POST['newemail'], $_POST['PWIid']);
					if (!($odba->mailinvitation($link, $_POST['newemail'], $langzone)))
					{
						$smarty->assign('alert', 3);
						$smarty->assign('s', $_POST['newemail']);
					}
					else
					{
						$smarty->assign('alert', 0);
					}
				}
			}
			else
			{
				$email=$_POST['CLemailid'];
				if (($odba->emailexists($email, $_GET['forumid'])))
				{
					$smarty->assign('alert', 2);
					$smarty->assign('s', $email);
				} else
				{
					$langzone = $odba->getuserlangzone($_SESSION['finf']['userid']);
					$link=$odba->addinvitation($_GET['forumid'], $email, $_POST['PWIid']);
					if (!($odba->mailinvitation($link, $email, $langzone)))
					{
						$smarty->assign('alert', 4);
						$smarty->assign('s', $email);
					}
					else
					{
						$smarty->assign('alert', 0);
					}
				}
			}
			$_GET['id']=$_GET['forumid'];
			$_GET['action']='inviteemail';
		}

		if ($_GET['action']=='resendemail')
		{
			$email = $odba->invdatabyinvid($_GET['id'], 'email');
			$secretkey = $odba->invdatabyinvid($_GET['id'], 'secretkey');
			
			$langzone = $odba->getuserlangzone($_SESSION['finf']['userid']);
			$link = "http://tforum.php.by?lang=$langzone&action=showforum&id=".$_GET['forumid']."&key=$secretkey";

			$odba->mailinvitation($link, $email, $langzone);
			
			$_GET['id']=$_GET['forumid'];
			$_GET['action']='inviteemail';
		}
		
		if ($_GET['action']=='removeinvited')
		{
			if (!$odba->invdatabyinvid($_GET['id'], 'email'))
			{
				$smarty->assign('alert', 5);
			}
			else
			{
				if (!($odba->removeinvited($_SESSION['finf']['userid'], $_GET['id'])))
				{
					$smarty->assign('alert', 3);
				} else
				{
					$smarty->assign('alert', 0);
				}
			}
			$_GET['id']=$_GET['forumid'];
			$_GET['action']='inviteemail';
		}
		
		if ($_GET['action']=='inviteemail')
		{
			$smarty->assign('forumid', $_GET['id']);
			$smarty->assign('rightslist', $odba->getinvites($_GET['id']));
			$smarty->assign('user_id', $_SESSION['finf']['userid']);
			$smarty->assign('pub', $odba->forumispub($_GET['id'])); //    Y / N
			$smarty->assign('pseudoslist', $odba->getpseudoslist($_SESSION['finf']['userid']));
			$smarty->assign('pseudosrights', $odba->getpseudosrights($_SESSION['finf']['userid'], $_GET['id']));
			$smarty->assign('currentrights', $odba->getrights($_SESSION['finf']['userid'], $_GET['id']));
			$smarty->assign('contactlist', $odba->getcontactlist($_SESSION['finf']['userid']));
			$smarty->assign('forumname', $odba->placeforum($_GET['id'], $_SESSION['finf']['userid']));
			$smarty->display('inviteemail.tpl');
		}
		
		
		
		
		if ($_GET['action']=='deletecontact')
		{
			$odba->deletecontact($_SESSION['finf']['userid'], $_GET['id']);
			$_GET['action']='contactlist';
		}

		if ($_GET['action']=='updatecontact')
		{
			$smarty->assign('contactlist', $odba->getcontactstring($_SESSION['finf']['userid'], $_GET['id']));
			$smarty->display('contactlistupdate.tpl');
		}

		if ($_GET['action']=='updatecontactset')
		{
			$odba->updatecontact($_SESSION['finf']['userid'], $_GET['id'], $_GET['email'], $_GET['mycomment'], $_GET['emailold']);
			$_GET['action']='contactlist';
		}

		if ($_GET['action']=='addcontact')
		{
			$a=$odba->addcontact($_SESSION['finf']['userid'], $_GET['id']);
			$_GET['action']='contactlist';
		}

		if ($_GET['action']=='addCLbyhand')
		{
			if (isset($_GET['newname']))
			{
				if ($odba->pseudoexists($_GET['newname']))
				{
					if ($odba->canadd($_SESSION['finf']['userid'], $odba->getpseudoidbyname($_GET['newname']))=='Y')
					{
						$odba->addcontact($_SESSION['finf']['userid'], $odba->getpseudoidbyname($_GET['newname']));
					}
					else
					{
						$smarty->assign('alert', 1);
						$smarty->assign('s', $_GET['newname']);
					}
				}
				else
				{
					$smarty->assign('alert', 1);
					$smarty->assign('s', $_GET['newname']);
				}
			}

			if (isset($_GET['newmail']))
			{
				$_GET['email']=$_GET['newmail'];
				$_GET['mycomment']=$_GET['comment'];

				if ($odba->addnotpseudo($_SESSION['finf']['userid'], $_GET['email'], $_GET['mycomment'])=='N')
				{
					$smarty->assign('alert', 2);
					$smarty->assign('s', $_GET['newmail']);
				}
			}

			$_GET['action']='contactlist';
		}

		if ($_GET['action']=='contactlist')
		{
			$smarty->assign('contactlist', $odba->getcontactlist($_SESSION['finf']['userid']));
			$smarty->assign('user', $_SESSION['finf']['username']);
			$smarty->assign('admin', $odba->isAdmin($_SESSION['finf']['userid']));
			$smarty->display('contactlist.tpl');
		}

		if ($_GET['action']=='invitationtree')
		{
			require ('webmail/invitations.php');
		}

		if ($_GET['action']=='sendmail')
		{
			require ('webmail/compose.php');
		}

		if ($_GET['action']=='problemlist')
		{
			require ('webmail/problem_list.php');
		}

		if ($_GET['action']=='acceptregister')
		{
			if ($odba->regsuccess($_POST['username'], $_POST['password'], $_POST['email'], $_POST['secrq'], $_POST['secra']))
			{
				$odba->wm_regsuccess();
				$smarty->assign('regsuccess', 'Y');
			}
			else
			{
				$smarty->assign('regsuccess', 'N');
				$smarty->assign('regfail', 1);
			}

			$smarty->assign('username', $_POST['username']);
			$smarty->assign('password', $_POST['password']);
			$smarty->assign('email', $_POST['email']);
			$smarty->assign('secrq', $_POST['secrq']);
			$smarty->assign('secra', $_POST['secra']);
			$_GET['action']='registernew';
		}
		else
		{
			$smarty->assign('regsuccess', 'N');
			$smarty->assign('regfail', 0);
			$smarty->assign('username', '');
			$smarty->assign('password', '');
			$smarty->assign('email', '');
			$smarty->assign('secra', '');
			$smarty->assign('secrq', '');
		}

		if ($_GET['action']=='registernew')
		{
			$odba->wm_registernew();
		}

		if ($_GET['action']=='addlangfromadding')
		{
			$odba->askaddlang($_GET['name'], $_SESSION['finf']['userid']);
			$_GET['action']='addtrans';
		}

		if ($_GET['action']=='addtrans')
		{
			$smarty->assign('basetrans', $odba->gettranslationvalues($_GET['id']));
			$smarty->assign('langzones', $odba->getlangzones());
			$smarty->assign('pseudoslist', $odba->getpseudoslist($_SESSION['finf']['userid']));
			$smarty->assign('based_id', $_GET['id']);
			$smarty->display('addtranslation.tpl');
		}

		if ($_GET['action']=='doaddtrans')
		{
			$odba->addtranslation($_POST, $_SESSION['finf']['userid']);
			$_GET['action']='translations';
		}

		if ($_GET['action']=='addlangfromediting')
		{
			$odba->askaddlang($_GET['name'], $_SESSION['finf']['userid']);
			$_GET['action']='edittrans';
		}

		if ($_GET['action']=='edittrans')
		{
			$smarty->assign('basetrans', $odba->gettranslationvalues($_GET['id']));
			$smarty->assign('langzones', $odba->getlangzones());
			$smarty->assign('pseudoslist', $odba->getpseudoslist($_SESSION['finf']['userid']));
			$smarty->assign('transoptions', $odba->gettransoptions($_GET['id']));
			$smarty->assign('based_id', $_GET['id']);
			$smarty->display('edittranslation.tpl');
		}

		if ($_GET['action']=='doedittrans')
		{
			$odba->edittranslation($_POST, $_SESSION['finf']['userid'], $_GET['id']);
			$_GET['action']='translations';
		}

		if ($_GET['action']=='usetrans')
		{
			$odba->settranslation4user($_SESSION['finf']['userid'], $_GET['id']);
			$_GET['action']='translations';
		}

		if ($_GET['action']=='translations')
		{
			$smarty->assign('translist', $odba->gettranslist());
			$smarty->assign('userid', $_SESSION['finf']['userid']);
			$smarty->display('conf.tpl');
			$smarty->display('translations.tpl');
		}

		if ($_GET['action']=='comptrans')
		{
			$smarty->assign('trans1', $odba->gettranslationvalues($_GET['id1']));
			$smarty->assign('trans2', $odba->gettranslationvalues($_GET['id2']));
			$smarty->display('comptrans.tpl');
		}

		if ($_GET['action']=='changeforumcom1')
		{
			$odba->changeforumcom1($_GET['id'], $_GET['newname']);
			$_GET['action']='foruminfo';
		}

		if ($_GET['action']=='changeforumcom2')
		{
			$odba->changeforumcom2($_GET['id'], $_GET['newname']);
			$_GET['action']='foruminfo';
		}

		if ($_GET['action']=='customrenameforumfrominfo')
		{
			$odba->customrenameforum($_GET['id'], $_GET['newname'], $_SESSION['finf']['userid']);
			$_GET['action']='foruminfo';
		}

		if ($_GET['action']=='subscribefrominfo')
		{
			$odba->subscribe($_GET['id'], $_SESSION['finf']['userid']);
			$_GET['action']='foruminfo';
		}

		if ($_GET['action']=='unsubscribefrominfo')
		{
			$odba->unsubscribe($_GET['id'], $_SESSION['finf']['userid']);
			$_GET['action']='foruminfo';
		}

		if ($_GET['action']=='invite')
		{
			if ($odba->invite($_GET['pname'], $_GET['perm'], $_GET['id'], $_GET['bypid'], $_GET['viewinv'])) $smarty->assign('alert', 1);
			else $smarty->assign('alert', 2);

			$smarty->assign('s', $_GET['pname']);
			$_GET['action']='foruminfo';
		}

		if ($_GET['action']=='invitebypid')
		{
			$odba->invitebypid($_GET['pid'], $_GET['perm'], $_GET['id'], $_GET['bypid'], $_GET['viewinv']);
			$_GET['action']='foruminfo';
		}

		if ($_GET['action']=='foruminfo')
		{
			$smarty->assign('info', $odba->getforuminfo($_SESSION['finf']['userid'], $_GET['id'], false));
			$smarty->assign('forumname', $odba->getforumnamebyid($_GET['id']));
			$smarty->assign('forum2ndname', $odba->forum2ndname($_GET['id'], $_SESSION['finf']['userid']));
			$smarty->assign('comments', $odba->getforumcomments($_GET['id']));
			$smarty->assign('invitations', $odba->accesseslist($_GET['id'], $_SESSION['finf']['userid']));
			$smarty->assign('userrights', $odba->getrights($_SESSION['finf']['userid'], $_GET['id']));
			$smarty->assign('forumid', $_GET['id']);
			$smarty->assign('forumpub', $odba->forumispub($_GET['id']));
			$smarty->assign('subscribed', $odba->subscribed($_GET['id'], $_SESSION['finf']['userid']));
			$smarty->assign('creator', $odba->getcreatorname($_GET['id']));
			$smarty->assign('contactlist', $odba->getcontactlist($_SESSION['finf']['userid']));
			$smarty->assign('pseudoslist', $odba->getpseudoslist($_SESSION['finf']['userid']));
			$smarty->assign('pseudosrights', $odba->getpseudosrights($_SESSION['finf']['userid'], $_GET['id']));
			$smarty->assign('currentrights', $odba->getrights($_SESSION['finf']['userid'], $_GET['id']));
			$smarty->assign('canviewinv', $odba->canviewinv($_SESSION['finf']['userid'], $smarty->get_template_vars('forumid'), $smarty->get_template_vars('currentrights')));
			$smarty->assign('canresign', $odba->canresign($_SESSION['finf']['userid'], $_GET['id']));
			$smarty->display('foruminfo.tpl');
		}

		if ($_GET['action']=='statistics')
		{
			$smarty->assign('info', $odba->getdbstatus());
			$smarty->display('conf.tpl');
			$smarty->display('statistics.tpl');
		}

		if ($_GET['action']=='viewrights')
		{
			$smarty->assign('rightslist', $odba->getrightslist($_GET['id']));
			$smarty->assign('forumname', $odba->placeforum($_GET['id'], $_SESSION['finf']['userid']));
			$smarty->display('viewrights.tpl');
		}

		if ($_GET['action']=='help')
		{
			$smarty->display('conf.tpl');
			$smarty->display('help.tpl');
		}
	}
	else
	{ //Datings START HERE :-) -------------*-*-*-*-*-*-*-*-*-*--*--*--*--*--*--*--*--*--
		require_once ('datingaccess.class.php');
		require_once ('glsimitation.class.php');
		require_once ('datingrelations.class.php');
		$daa=new DatingAccesses($datrel);
		$glsi=new GLSImitation();
		$datrel=new DatingRelations($odba, $daa, $glsi);
		$glsi->setdatrel($datrel);
		$daa->setdatrel($datrel);

		$aid=$daa->accountexists($_SESSION['finf']['userid']);

		if ($aid)
		{
			$astate=$daa->getaccountstate($aid);
		}
		else
		{
			$astate=-1;
		}

		if ($_GET['action']=='dating_create')
		{
			if (!$aid)
			{
				$ct=$smarty->get_template_vars('ct');
				$daa->registeraccount($_GET['pid'], $_SESSION['finf']['userid'], $odba->getMB($_SESSION['finf']['userid']), $ct[223]);
				$aid=$daa->accountexists($_SESSION['finf']['userid']);

				if ($aid)
				{
					$astate=$daa->getaccountstate($aid);
				}
				else
				{
					$astate=-1;
				}
			}
			else
			{
				$smarty->assign('alert', 1);
			}

			$_GET['action']='datings';
		}

		if ($_GET['action']=='dating_movematch')
		{
			$daa->movematch($aid, $_GET['from'], $_GET['where'], $_GET['id']);
		}

		$smarty->assign('astate', $astate);
		$state2=$daa->translatestate($astate);

		if ($astate!=-1) $smarty->assign('countfoldersmatches', $daa->countfoldersmatches($aid));

		switch ($_GET['action'])
		{
		case 'dating_enterinfosubmit':
			$daa->enterinfo($aid, $_POST);
			$astate=$daa->getaccountstate($aid);
			$state2=$daa->translatestate($astate);
			$_GET['action']='datings';
			break;
		case 'dating_enterlanginfoaccept':
			$daa->setlangs($_POST, $aid, $state2);
			$astate=$daa->getaccountstate($aid);
			$state2=$daa->translatestate($astate);
			$_GET['action']='datings';
			break;
		case 'dating_enterinfo':
			$smarty->assign('criteria', $daa->getcriteria($aid, $odba->getuserlangzone($_SESSION['finf']['userid'])));
			$smarty->assign('countcriteria', $daa->countcriteria());
			$smarty->assign('disabled', false);
			$smarty->assign('state2', $state2);
			$smarty->display('datingmenu.tpl');
			$smarty->display('datinginfo.tpl');
			break;
		case 'dating_enterlanginfo':
			$res=$daa->getlangslist($odba->getuserlangzone($_SESSION['finf']['userid']));
			$smarty->assign('langlist', $res['langlist']);
			$smarty->assign('langcases', $res['langcases']);
			$smarty->assign('state2', $state2);
			$smarty->assign('enabled', true);
			$smarty->assign('langinfo', array('learn'=>0));
			$smarty->display('datingmenu.tpl');
			$smarty->display('datinglanginfo.tpl');
			break;
		case 'dating_seeinfo':
			$smarty->assign('criteria', $daa->getcriteria($aid, $odba->getuserlangzone($_SESSION['finf']['userid'])));
			$smarty->assign('countcriteria', $daa->countcriteria());
			$smarty->assign('disabled', true);
			$smarty->assign('answers', $daa->getusercriteria4editing($aid));
			$smarty->assign('state2', $state2);
			$smarty->display('datingmenu.tpl');
			$smarty->display('datinginfo.tpl');
			break;
		case 'dating_uploadphoto':
			$smarty->assign('photofn', $daa->getuserphoto($aid));
			$smarty->assign('state2', $state2);
			$smarty->display('datingmenu.tpl');
			$smarty->display('datingphoto.tpl');
			break;
		case 'dating_uploadphotosubmit':
			$daa->uploadphoto($aid, $_FILES['photo']);
			$astate=$daa->getaccountstate($aid);
			$state2=$daa->translatestate($astate);
			$smarty->assign('photofn', $daa->getuserphoto($aid));
			$smarty->assign('state2', $state2);
			$smarty->display('datingmenu.tpl');
			$smarty->display('datingphoto.tpl');
			break;
		case 'dating_unlinkphoto':
			$daa->removeuserphoto($aid);
			$astate=$daa->getaccountstate($aid);
			$state2=$daa->translatestate($astate);
			$smarty->assign('photofn', $daa->getuserphoto($aid));
			$smarty->assign('state2', $state2);
			$smarty->display('datingmenu.tpl');
			$smarty->display('datingphoto.tpl');
			break;
		case 'dating_activate':
			$daa->activate($aid, $_GET['choice'], $_GET['pseudoid']);
			$astate=$daa->getaccountstate($aid);
			$state2=$daa->translatestate($astate);
			$smarty->assign('state2', $state2);
			$_GET['action']='datings';
			break;
		case 'dating_deactivate':
			$daa->deactivate($aid);
			$state2=$daa->translatestate($astate);
			$smarty->assign('state2', $state2);
			$_GET['action']='datings';
			break;
		case 'dating_help':
			$smarty->assign('state2', $state2);
			$smarty->display('datingmenu.tpl');
			$smarty->display('datinghelp.tpl');
			break;
		case 'dating_seelanginfo':
			$res=$daa->getlangslist($odba->getuserlangzone($_SESSION['finf']['userid']));
			$smarty->assign('langlist', $res['langlist']);
			$smarty->assign('langcases', $res['langcases']);
			$smarty->assign('langinfo', $daa->getlanginfo($aid));
			$smarty->assign('enabled', false);
			$smarty->assign('state2', $state2);
			$smarty->display('datingmenu.tpl');
			$smarty->display('datinglanginfo.tpl');
			break;
		case 'dating_advices_forumF':
			$tlist=$odba->getthreadslist(2, $_SESSION['finf']['userid']);
			$smarty->assign('threadslist', $tlist['a']);
			$smarty->assign('newamount', $tlist['new']);
			$smarty->assign('photospaths', $daa->getphotospaths());
			$smarty->assign('adminallowed', 'Y');
			$smarty->assign('forumid', 2);
			$smarty->assign('currentrights', $odba->getrights($_SESSION['finf']['userid'], 2));
			$smarty->assign('canviewinv', $odba->canviewinv($_SESSION['finf']['userid'], $smarty->get_template_vars('forumid'), $smarty->get_template_vars('currentrights')));
			$smarty->assign('forumpub', 'Y');
			$smarty->assign('place1', '');
			$smarty->assign('place2', $odba->placeforum(2, $_SESSION['finf']['userid']));
			$smarty->assign('place4', $odba->placecomment(2));
			$smarty->assign('canresign', $odba->canresign($_SESSION['finf']['userid'], 2));
			$smarty->assign('state2', $state2);
			$smarty->display('datingmenu.tpl');
			$smarty->display('datingshowthreads.tpl');
			break;
		case 'dating_advices_forumM':
			$tlist=$odba->getthreadslist(1, $_SESSION['finf']['userid']);
			$smarty->assign('threadslist', $tlist['a']);
			$smarty->assign('newamount', $tlist['new']);
			$smarty->assign('photospaths', $daa->getphotospaths());
			$smarty->assign('adminallowed', 'Y');
			$smarty->assign('forumid', 1);
			$smarty->assign('currentrights', $odba->getrights($_SESSION['finf']['userid'], 1));
			$smarty->assign('canviewinv', $odba->canviewinv($_SESSION['finf']['userid'], $smarty->get_template_vars('forumid'), $smarty->get_template_vars('currentrights')));
			$smarty->assign('forumpub', 'Y');
			$smarty->assign('place1', '');
			$smarty->assign('place2', $odba->placeforum(1, $_SESSION['finf']['userid']));
			$smarty->assign('place4', $odba->placecomment(1));
			$smarty->assign('canresign', $odba->canresign($_SESSION['finf']['userid'], 1));
			$smarty->assign('state2', $state2);
			$smarty->display('datingmenu.tpl');
			$smarty->display('datingshowthreads.tpl');
			break;
		case 'dating_createforum':
			$_GET['id']=$daa->createforum($aid, $_GET['aid']);
			$_GET['action']='dating_showforum';
		case 'dating_showforum':
			$_GET['id']=$odba->getanonlythreadindex($_GET['id']);
		case 'dating_showmsgs':
			$smarty->assign('messageslist', $odba->getmessageslist($_GET['id'], $_SESSION['finf']['userid']));
			$smarty->assign('threadid', $_GET['id']);
			$smarty->assign('currentuser', $_SESSION['finf']['userid']);
			$smarty->assign('pseudoslist', $odba->getpseudoslist($_SESSION['finf']['userid']));
			$smarty->assign('forumid', $odba->thread2forum($_GET['id']));
			$smarty->assign('currentrights', $odba->getrights($_SESSION['finf']['userid'], $odba->thread2forum($_GET['id'])));
			$smarty->assign('canviewinv', $odba->canviewinv($_SESSION['finf']['userid'], $smarty->get_template_vars('forumid'), $smarty->get_template_vars('currentrights')));
			$smarty->assign('forumpub', $odba->forumispub($odba->thread2forum($_GET['id'])));
			$smarty->assign('place1', '');
			$smarty->assign('place2', $odba->placeforum($odba->thread2forum($_GET['id']), $_SESSION['finf']['userid']));
			$smarty->assign('place4', $odba->placecomment($odba->thread2forum($_GET['id'])));
			$smarty->assign('contactlist', $odba->getcontactlist($_SESSION['finf']['userid']));
			$smarty->assign('canresign', $odba->canresign($_SESSION['finf']['userid'], $odba->thread2forum($_GET['id'])));
			$smarty->assign('pseudosrights', $odba->getpseudosrights($_SESSION['finf']['userid'], $odba->thread2forum($_GET['id'])));
			$smarty->assign('place3', $odba->placethread($smarty->get_template_vars('threadid')));
			$smarty->assign('only1thread', !$odba->threadsexist($smarty->get_template_vars('forumid')));
			$ph=$daa->getphoto($_GET['id']);
			$smarty->assign('photo', $ph);
			if (!$ph)
			{
				$smarty->assign('photoZ', $daa->get_photoZ($_GET['id'], $aid));
			}
			$smarty->assign('state2', $state2);
			$smarty->display('datingmenu.tpl');
			$smarty->display('datingshowmessages.tpl');
			break;
		case 'dating_newreply':
			if (isset($_POST['valid']))
			{
				$a=true;
			}
			else
			{
				$a=false;
			}
			$odba->newreply($_GET['id'], $_POST['_pseudoid'], $_POST['_title'], $_POST['_body'], $a);
			$smarty->assign('messageslist', $odba->getmessageslist($_GET['id'], $_SESSION['finf']['userid']));
			$smarty->assign('threadid', $_GET['id']);
			$smarty->assign('forumid', $odba->thread2forum($_GET['id']));
			$smarty->assign('currentuser', $_SESSION['finf']['userid']);
			$smarty->assign('pseudoslist', $odba->getpseudoslist($_SESSION['finf']['userid']));
			$smarty->assign('currentrights', $odba->getrights($_SESSION['finf']['userid'], $odba->thread2forum($_GET['id'])));
			$smarty->assign('canviewinv', $odba->canviewinv($_SESSION['finf']['userid'], $smarty->get_template_vars('forumid'), $smarty->get_template_vars('currentrights')));
			$smarty->assign('forumpub', $odba->forumispub($odba->thread2forum($_GET['id'])));
			$smarty->assign('place1', $odba->placefolder($odba->forum2folder($odba->thread2forum($_GET['id']), $_SESSION['finf']['userid'])));
			$smarty->assign('place2', $odba->placeforum($odba->thread2forum($_GET['id']), $_SESSION['finf']['userid']));
			$smarty->assign('place4', $odba->placecomment($odba->thread2forum($_GET['id'])));
			$smarty->assign('contactlist', $odba->getcontactlist($_SESSION['finf']['userid']));
			$smarty->assign('canresign', $odba->canresign($_SESSION['finf']['userid'], $odba->thread2forum($_GET['id'])));
			$smarty->assign('pseudosrights', $odba->getpseudosrights($_SESSION['finf']['userid'], $odba->thread2forum($_GET['id'])));
			$smarty->assign('place3', $odba->placethread($smarty->get_template_vars('threadid')));
			$smarty->assign('only1thread', !$odba->threadsexist($smarty->get_template_vars('forumid')));
			$smarty->assign('state2', $state2);
			$ph=$daa->getphoto($_GET['id']);
			$smarty->assign('photo', $ph);
			if (!$ph)
			{
				$smarty->assign('photoZ', $daa->get_photoZ($_GET['id'], $aid));
			}
			$smarty->display('datingmenu.tpl');
			$smarty->display('datingshowmessages.tpl');
			break;
		case 'dating_send':
			$smarty->assign('state2', $state2);
			$smarty->display('datingmenu.tpl');
			$smarty->display('datingsend.tpl');
			break;
		case 'dating_send_accepted':
			$daa->sendaccount2all($aid);
			$astate=$daa->getaccountstate($aid);
			$state2=$daa->translatestate($astate);
			$smarty->assign('state2', $state2);
			$_GET['action']='datings';
			break;
		case 'dating_folderssettings':
			if (isset($_POST['folderssettings']))
			{
				if (!isset($_POST['crit'])) $_POST['crit']=array();

				$daa->setfolderssettings($aid, $_POST['folderssettings'], $_POST['crit']);
			}
			$smarty->assign('criteria', $daa->getcriterianocases($odba->getuserlangzone($_SESSION['finf']['userid'])));
			$s=$daa->getfolderssettings($aid);
			$smarty->assign('folderssettings', $s[1]);
			$smarty->assign('crit', $s[2]);
			$smarty->assign('state2', $state2);
			$smarty->display('datingmenu.tpl');
			$smarty->display('datingfolderssettings.tpl');
			break;
		case 'dating_folder':
			if (!isset($_GET['fromi'])) $_GET['fromi']=1;
			$params2=$daa->getfolderssettings($aid);
			$params=$params2[1];
			$smarty->assign('height', $params[strtolower($_GET['where']).'h']);
			$smarty->assign('width', $params[strtolower($_GET['where']).'w']);
			$smarty->assign('showphoto', $params[strtolower($_GET['where']).'_sp']);
			$smarty->assign('showforumlink', 'Y');
			$smarty->assign('languages', $params['languages']);
			$smarty->assign('badness', $params['badness']);
			$smarty->assign('criteria', $daa->getcriterianocases($odba->getuserlangzone($_SESSION['finf']['userid'])));
			$smarty->assign('whichcriteria', $params2[2]);
			$content=$daa->getparameters($aid, strtolower($_GET['where']), $_GET['fromi'], $params[strtolower($_GET['where']).'h']*$params[strtolower($_GET['where']).'w'], $params[strtolower($_GET['where']).'w'], $odba->getuserlangzone($_SESSION['finf']['userid']));
			$smarty->assign('content', $content);
			$smarty->assign('empty', count($content)==0);
			$smarty->assign('cur_fromi', $_GET['fromi']);
			$smarty->assign('nextpage_fromi', $_GET['fromi']+($params[strtolower($_GET['where']).'h']*$params[strtolower($_GET['where']).'w']));
			$smarty->assign('prevpage_fromi', $_GET['fromi']-($params[strtolower($_GET['where']).'h']*$params[strtolower($_GET['where']).'w']));
			switch (strtolower($_GET['where']))
			{
			case 'u':
				$foldernameindex=187;
				break;
			case 't':
				$foldernameindex=188;
				break;
			case 'd':
				$foldernameindex=189;
				break;
			case 's':
				$foldernameindex=190;
				break;
			case 'sp':
				$foldernameindex=191;
				break;
			}
			$smarty->assign('foldernameindex', $foldernameindex);
			$smarty->assign('folderchar', $_GET['where']);
			$smarty->assign('state2', $state2);
			$smarty->display('datingmenu.tpl');
			$smarty->display('datingfolder.tpl');
			break;
		case 'dating_entermplace':
			$smarty->assign('state2', $state2);
			$smarty->display('datingmenu.tpl');
			$smarty->assign('countries', $daa->getcountries($odba->getuserlangzone($_SESSION['finf']['userid'])));
			$smarty->display('datingmplace.tpl');
			break;
		case 'dating_entermplace_handle':
			$daa->handle_mplace($aid, $_POST);
			$astate=$daa->getaccountstate($aid);
			$state2=$daa->translatestate($astate);
			$smarty->assign('state2', $state2);
			$smarty->assign('disabled', false);
			$_GET['action']='datings';
			break;
		case 'dating_seemplace':
			$smarty->assign('state2', $state2);
			$smarty->display('datingmenu.tpl');
			$smarty->assign('countries', $daa->getcountries($odba->getuserlangzone($_SESSION['finf']['userid'])));
			$smarty->assign('entered', $daa->getmplace4user($aid));
			$smarty->assign('disabled', true);
			$smarty->display('datingmplace.tpl');
			break;
		case 'dating_accountmanagement':
			$smarty->assign('state2', $state2);
			$smarty->display('datingmenu.tpl');
			$smarty->assign('pseudoslist', $odba->getpseudoslist($_SESSION['finf']['userid']));
			$smarty->assign('asking', $daa->getaskingstatus($aid));
			$smarty->display('datingmanagement.tpl');
			break;
		case 'dating_stopasking':
			$daa->ask4advices($aid, 0);
			$_GET['action']='datings';
			break;
		case 'dating_startasking':
			$daa->ask4advices($aid, 1);
			$_GET['action']='datings';
			break;
		case 'datings': break;
		default:
			echo 'ERROR: INVALID DATING ACTION';
			$_GET['action']='datings';
			break;
		}

		if ($_GET['action']=='datings')
		{
			$smarty->assign('accountexists', $aid);

			if (!$aid)
			{
				$smarty->assign('pseudoslist', $odba->getpseudoslist($_SESSION['finf']['userid']));
			}

			$smarty->assign('state2', $state2);
			$smarty->display('datingmenu.tpl');
			$smarty->display('datingmain.tpl');
		}
	}
}
else
{


	//-*--*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

	$smarty->assign('guestlogin', 'N');
	$smarty->display('loginform.tpl');
	$smarty->assign('anonly3', true); //  
	$smarty->display('mainframe.tpl');

	if ($_GET['action']=='acceptregister')
	{
		if ($odba->regsuccess($_POST['username'], $_POST['password'], $_POST['email'], $_POST['secrq'], $_POST['secra']))
		{
			$odba->wm_regsuccess();
			$smarty->assign('regsuccess', 'Y');
		}
		else
		{
			$smarty->assign('regsuccess', 'N');
			$smarty->assign('regfail', 1);
		}

		$smarty->assign('username', $_POST['username']);
		$smarty->assign('password', $_POST['password']);
		$smarty->assign('email', $_POST['email']);
		$smarty->assign('secrq', $_POST['secrq']);
		$smarty->assign('secra', $_POST['secra']);
		$_GET['action']='registernew';
	}
	else
	{
		$smarty->assign('regsuccess', 'N');
		$smarty->assign('regfail', 0);
		$smarty->assign('username', '');
		$smarty->assign('password', '');
		$smarty->assign('email', '');
		$smarty->assign('secra', '');
		$smarty->assign('secrq', '');
	}

	if ($_GET['action']=='registernew')
	{
		$odba->wm_registernew();
	}

	if ($_GET['action']=='forgotpassword')
	{
		$smarty->assign('step', 1);
		$smarty->assign('alert', 0);
		$smarty->display('forgotpassword.tpl');
	}

	if ($_GET['action']=='remindpass2')
	{
		if ($odba->goodanswer($odba->getuseridbyname($_GET['login']), $_POST['secra']))
		{
			$aa=$odba->getfulluserinfo($odba->getuseridbyname($_GET['login']));
			$smarty->assign('step', 3);
			$smarty->assign('username', $aa['login']);
			$smarty->assign('password', $aa['pass']);
			$smarty->assign('email', $aa['email']);
			$smarty->assign('secrq', $aa['secr_q']);
			$smarty->assign('secra', $aa['secr_a']);
			$smarty->display('forgotpassword.tpl');
		}
		else
		{
			$_GET['action']='remindpass';
			$_POST['login']=$_GET['login'];
			$smarty->assign('alert', '!');
		}
	}

	if ($_GET['action']=='remindpass')
	{
		$userid=$odba->getuseridbyname($_POST['login']);

		if ($userid==-1)
		{
			$smarty->assign('step', 1);
			$smarty->assign('alert', 1);
		}
		else
		{
			$smarty->assign('step', 2);
			$smarty->assign('login', $_POST['login']);
			$smarty->assign('secrq', $odba->getsecretquestion($userid));
		}

		$smarty->display('forgotpassword.tpl');
	}

	//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* FOR GUESTS -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*--*-*-*-*

	if (isset($_GET['loggedin']))
	{
		$odba->newreply($_GET['id'], $_POST['_pseudoid'], $_POST['_title'], $_POST['_body'], false);
		$_GET['action']='';
		$smarty->assign('alert', 1);
	}

	if ($_GET['action']=='')
	{
		$_GET['action']='showfolder';
	}

	if ($_GET['action']=='newreply')
	{
		if (isset($_GET['key']))
		{
			if ($odba->isinvitedkey($_GET['key'], $odba->forumbythread($_GET['id'])))
			{
				$odba->newPUBINVITEDreply($_GET['id'], $_POST['_title'], $_POST['_body'], $_GET['key']);
				$smarty->assign('secretkey', $_GET['key']);
			} else $odba->newPUBLICreply($_GET['id'], $_POST['_title'], $_POST['_body']);
		} else $odba->newPUBLICreply($_GET['id'], $_POST['_title'], $_POST['_body']);
		
		$smarty->assign('messageslist', $odba->getPUBLICmessageslist($_GET['id']));
		$smarty->assign('threadid', $_GET['id']);
		$smarty->assign('forumid', $odba->thread2forum($_GET['id']));
		$smarty->assign('place2', $odba->placeforum($_GET['id'], -1));
		$smarty->assign('guestcanreply', $odba->guestcanreply($_GET['id']));
		$smarty->assign('back2folder', 0);
		$smarty->display('showPUBLICmessages.tpl');
	}

	if ($_GET['action']=='showthread')
	{
		if (isset($_GET['key']) && $odba->isinvitedkey($_GET['key'], $odba->forumbythread($_GET['id'])))
		{
			$smarty->assign('secretkey', $_GET['key']);
		}
		$smarty->assign('messageslist', $odba->getPUBLICmessageslist($_GET['id']));
		$smarty->assign('threadid', $_GET['id']);
		$smarty->assign('forumid', $odba->thread2forum($_GET['id']));
		$smarty->assign('place2', $odba->placeforum($odba->thread2forum($_GET['id']), -1));
		$smarty->assign('guestcanreply', $odba->guestcanreply($odba->thread2forum($_GET['id'])));
		$smarty->assign('back2folder', 0);
		$smarty->display('showPUBLICmessages.tpl');
	}

	if ($_GET['action']=='showforum')
	{
		if ($odba->threadsexist($_GET['id']))
		{
			if (isset($_GET['key']) && $odba->isinvitedkey($_GET['key'], $_GET['id'])) $smarty->assign('secretkey', $_GET['key']);
			$tlist=$odba->getthreadslist($_GET['id'], 0);
			$smarty->assign('threadslist', $tlist['a']);
			$smarty->assign('forumid', $_GET['id']);
			$smarty->assign('place2', $odba->placeforum($_GET['id'], -1));
			$smarty->display('showPUBLICthreads.tpl');
		}
		else
		{
			if (isset($_GET['key']) && $odba->isinvitedkey($_GET['key'], $_GET['id'])) $smarty->assign('secretkey', $_GET['key']);
			$smarty->assign('messageslist', $odba->getPUBLICmessageslist($odba->getanonlythreadindex($_GET['id'])));
			$smarty->assign('threadid', $odba->getanonlythreadindex($_GET['id']));
			$smarty->assign('forumid', $_GET['id']);
			$smarty->assign('place2', $odba->placeforum($_GET['id'], -1));
			$smarty->assign('guestcanreply', $odba->guestcanreply($_GET['id']));
			$smarty->assign('back2folder', 1);
			$smarty->assign('forumid', $odba->thread2forum($_GET['id']));
			$smarty->display('showPUBLICmessages.tpl');
		}
	}

	if ($_GET['action']=='showfolder')
	{
		$smarty->assign('forumslist', $odba->getPUBLICforumslist());
		$smarty->display('showPUBLICforums.tpl');
	}

	if ($_GET['action']=='viewpseudo')
	{
		$smarty->assign('pseudodata', $odba->getpseudodata($_GET['id']));
		$smarty->assign('fromid', $_GET['fromid']);
		$smarty->display('viewpseudoPUBLIC.tpl');
	}

	if ($_GET['action']=='help')
	{
		$smarty->display('help4guests.tpl');
	}
}

$smarty->display('footer.tpl');
?>