<?php

/**
 *
 **/

class Object_Action {
	var $aErrors = array();

	function Object_Action() {
	}

	/**
	 * @access	public
	 *
	 * @return	object	ActionErrors
	 */
	function &getErrors() {
		return $this->aErrors;
	}

	/**
	 * @access	private
	 *
	 * @param	array	$name
	 * @param	object	$error
	 *
	 * @return	void
	 */
	function addError($sName, $oError) {
		$this->aErrors[$sName] = $oError;
	}

	/**
	 * @access	private
	 *
	 * @param	object	$errors
	 *
	 * @return	void
	 */
	function addErrors($aErrors) {
		$this->aErrors = array_merge($this->aErrors,$aErrors);
	}

	/**
	 * @access	private
	 *
	 * @return	boolean
	 */
	function hasErrors() {
		return (0 != sizeof($this->aErrors) );
	}

}
